/* Generated automatically by the program `genextract'
   from the machine description file `md'.  */

#define IN_TARGET_CODE 1
#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "tm.h"
#include "rtl.h"
#include "insn-config.h"
#include "recog.h"
#include "diagnostic-core.h"

/* This variable is used as the "location" of any missing operand
   whose numbers are skipped by a given pattern.  */
static rtx junk ATTRIBUTE_UNUSED;

void
insn_extract (rtx_insn *insn)
{
  rtx *ro = recog_data.operand;
  rtx **ro_loc = recog_data.operand_loc;
  rtx pat = PATTERN (insn);
  int i ATTRIBUTE_UNUSED; /* only for peepholes */

  if (flag_checking)
    {
      memset (ro, 0xab, sizeof (*ro) * MAX_RECOG_OPERANDS);
      memset (ro_loc, 0xab, sizeof (*ro_loc) * MAX_RECOG_OPERANDS);
    }

  switch (INSN_CODE (insn))
    {
    default:
      /* Control reaches here if insn_extract has been called with an
         unrecognizable insn (code -1), or an insn whose INSN_CODE
         corresponds to a DEFINE_EXPAND in the machine description;
         either way, a bug.  */
      if (INSN_CODE (insn) < 0)
        fatal_insn ("unrecognizable insn:", insn);
      else
        fatal_insn ("insn with invalid code number:", insn);

    case 137:  /* umulsidi3 */
    case 136:  /* mulsidi3 */
    case 135:  /* umulhisi3 */
    case 134:  /* mulhisi3 */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (pat, 1), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (pat, 1), 1), 0));
      break;

    case 117:  /* *bitbranchpsi4_z */
    case 116:  /* *bitbranchhi4_z */
    case 115:  /* *bitbranchqi4_z */
    case 114:  /* *bitbranchpsi4_z */
    case 113:  /* *bitbranchhi4_z */
    case 112:  /* *bitbranchqi4_z */
      ro[0] = *(ro_loc[0] = &XEXP (XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0), 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0), 0), 2));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 2), 0));
      break;

    case 111:  /* *bitbranchpsi4_z */
    case 110:  /* *bitbranchhi4_z */
    case 109:  /* *bitbranchqi4_z */
    case 108:  /* *bitbranchpsi4_z */
    case 107:  /* *bitbranchhi4_z */
    case 106:  /* *bitbranchqi4_z */
      ro[0] = *(ro_loc[0] = &XEXP (XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0), 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0), 0), 2));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 1), 0));
      break;

    case 105:  /* *bitbranchpsi4 */
    case 104:  /* *bitbranchhi4 */
    case 103:  /* *bitbranchqi4 */
    case 102:  /* *bitbranchpsi4 */
    case 101:  /* *bitbranchhi4 */
    case 100:  /* *bitbranchqi4 */
      ro[0] = *(ro_loc[0] = &XEXP (XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0), 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0), 0), 1));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 2), 0));
      break;

    case 99:  /* *bitbranchpsi4 */
    case 98:  /* *bitbranchhi4 */
    case 97:  /* *bitbranchqi4 */
    case 96:  /* *bitbranchpsi4 */
    case 95:  /* *bitbranchhi4 */
    case 94:  /* *bitbranchqi4 */
      ro[0] = *(ro_loc[0] = &XEXP (XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0), 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0), 0), 1));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 1), 0));
      break;

    case 93:  /* cbranchhi4_reversed */
    case 92:  /* cbranchqi4_reversed */
    case 91:  /* cbranchpsi4_reversed */
    case 90:  /* cbranchhi4_real */
    case 89:  /* cbranchqi4_real */
    case 88:  /* cbranchpsi4_real */
      ro[0] = *(ro_loc[0] = &XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0), 1));
      ro[3] = *(ro_loc[3] = &XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 1), 0));
      break;

    case 86:  /* jump */
      ro[0] = *(ro_loc[0] = &XEXP (XEXP (pat, 1), 0));
      break;

    case 82:  /* call_internal */
      ro[0] = *(ro_loc[0] = &XEXP (XEXP (pat, 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (pat, 1));
      break;

    case 127:  /* delay_cycles_end */
    case 126:  /* delay_cycles_start */
    case 124:  /* bis_SR */
    case 123:  /* bic_SR */
    case 77:  /* epilogue_helper */
      ro[0] = *(ro_loc[0] = &XVECEXP (pat, 0, 0));
      break;

    case 58:  /* extend_and_shift2_hipsi2 */
    case 57:  /* extend_and_shift1_hipsi2 */
      ro[0] = *(ro_loc[0] = &XEXP (XEXP (pat, 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (pat, 1), 0), 0));
      break;

    case 56:  /* zero_extendhisipsi2 */
    case 53:  /* extendhipsi2 */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (pat, 1), 0), 0));
      break;

    case 125:  /* andneghi3 */
    case 83:  /* call_value_internal */
    case 35:  /* bicpsi3 */
    case 34:  /* bichi3 */
    case 33:  /* bicqi3 */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (pat, 1), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (pat, 1), 1));
      break;

    case 25:  /* addchi4_cy */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (pat, 1), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (pat, 1), 0), 1));
      break;

    case 24:  /* addhi3_cy_i */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 1));
      ro[3] = *(ro_loc[3] = &XEXP (XEXP (XEXP (XEXP (XVECEXP (pat, 0, 1), 1), 0), 0), 1));
      recog_data.dup_loc[0] = &XEXP (XEXP (XEXP (XEXP (XEXP (XVECEXP (pat, 0, 1), 1), 0), 0), 0), 0);
      recog_data.dup_num[0] = 1;
      break;

    case 23:  /* addhi3_cy */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 1));
      recog_data.dup_loc[0] = &XEXP (XEXP (XEXP (XEXP (XEXP (XVECEXP (pat, 0, 1), 1), 0), 0), 0), 0);
      recog_data.dup_num[0] = 1;
      recog_data.dup_loc[1] = &XEXP (XEXP (XEXP (XEXP (XEXP (XVECEXP (pat, 0, 1), 1), 0), 0), 1), 0);
      recog_data.dup_num[1] = 2;
      break;

    case 21:  /* addsipsi3 */
      ro[0] = *(ro_loc[0] = &XEXP (XEXP (pat, 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (pat, 1), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (pat, 1), 1));
      break;

    case 73:  /* 430x_logical_shift_right */
    case 67:  /* 430x_arithmetic_shift_right */
    case 63:  /* 430x_shift_left */
    case 44:  /* xorpsi3 */
    case 43:  /* xorhi3 */
    case 42:  /* xorqi3 */
    case 41:  /* iorpsi3 */
    case 40:  /* iorhi3 */
    case 39:  /* iorqi3 */
    case 38:  /* andpsi3 */
    case 37:  /* andhi3 */
    case 36:  /* andqi3 */
    case 32:  /* *bicpsi_cg */
    case 31:  /* *bichi_cg */
    case 30:  /* *bicqi_cg */
    case 29:  /* subsi3 */
    case 28:  /* subhi3 */
    case 27:  /* subqi3 */
    case 26:  /* subpsi3 */
    case 22:  /* addsi3 */
    case 20:  /* addhi3 */
    case 19:  /* addqi3 */
    case 18:  /* addpsi3 */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (pat, 1), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (pat, 1), 1));
      break;

    case 15:  /* movpsi */
    case 14:  /* movsi_x */
    case 12:  /* movhi */
    case 11:  /* movqi */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (pat, 1));
      break;

    case 76:  /* srll_2x */
    case 75:  /* srll_1 */
    case 74:  /* srlp_1 */
    case 72:  /* srli_1 */
    case 71:  /* sral_2 */
    case 70:  /* sral_1 */
    case 69:  /* srap_2 */
    case 68:  /* srap_1 */
    case 66:  /* srai_1 */
    case 65:  /* slll_2 */
    case 64:  /* slll_1 */
    case 62:  /* slli_1 */
    case 61:  /* truncsipsi2 */
    case 60:  /* extendpsisi2 */
    case 59:  /* zero_extendpsisi2 */
    case 55:  /* zero_extendhisi2 */
    case 54:  /* zero_extendqisi2 */
    case 52:  /* extendhisi2 */
    case 51:  /* truncpsihi2 */
    case 50:  /* zero_extendhipsi2 */
    case 49:  /* zero_extendqihi2 */
    case 48:  /* extendqihi2 */
    case 47:  /* one_cmplpsi2 */
    case 46:  /* one_cmplhi2 */
    case 45:  /* one_cmplqi2 */
    case 17:  /* *movpsihi2_lo */
    case 16:  /* movsipsi2 */
    case 13:  /* movsi_s */
    case 10:  /* movqi_topbyte */
    case 9:  /* movqihi */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (pat, 1), 0));
      break;

    case 133:  /* delay_cycles_1 */
    case 132:  /* delay_cycles_2 */
    case 122:  /* pop_intr_state */
    case 121:  /* push_intr_state */
    case 120:  /* enable_interrupts */
    case 119:  /* disable_interrupts */
    case 118:  /* nop */
    case 85:  /* msp430_eh_epilogue */
    case 84:  /* msp_return */
    case 81:  /* msp430_refsym_need_exit */
    case 80:  /* epilogue_start_marker */
    case 79:  /* prologue_end_marker */
    case 78:  /* prologue_start_marker */
    case 8:  /* swap_and_shrink */
    case 7:  /* grow_and_swap */
      break;

    case 6:  /* popm */
      ro[0] = *(ro_loc[0] = &XVECEXP (pat, 0, 0));
      ro[1] = *(ro_loc[1] = &XVECEXP (pat, 0, 1));
      ro[2] = *(ro_loc[2] = &XVECEXP (pat, 0, 2));
      break;

    case 5:  /* popa */
    case 4:  /* pop */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      break;

    case 131:  /* delay_cycles_16x */
    case 130:  /* delay_cycles_16 */
    case 129:  /* delay_cycles_32x */
    case 128:  /* delay_cycles_32 */
    case 3:  /* pushm */
      ro[0] = *(ro_loc[0] = &XVECEXP (pat, 0, 0));
      ro[1] = *(ro_loc[1] = &XVECEXP (pat, 0, 1));
      break;

    case 87:  /* indirect_jump */
    case 2:  /* pusha */
    case 1:  /* push */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 1));
      break;

    }
}
