/* Generated automatically by the program `genoutput'
   from the machine description file `md'.  */

#define IN_TARGET_CODE 1
#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "backend.h"
#include "predict.h"
#include "tree.h"
#include "rtl.h"
#include "flags.h"
#include "alias.h"
#include "varasm.h"
#include "stor-layout.h"
#include "calls.h"
#include "insn-config.h"
#include "expmed.h"
#include "dojump.h"
#include "explow.h"
#include "memmodel.h"
#include "emit-rtl.h"
#include "stmt.h"
#include "expr.h"
#include "insn-codes.h"
#include "tm_p.h"
#include "regs.h"
#include "conditions.h"
#include "insn-attr.h"

#include "recog.h"

#include "diagnostic-core.h"
#include "output.h"
#include "target.h"
#include "tm-constrs.h"

static const char *
output_7 (rtx *operands ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
#line 159 "../../../gcc/gcc/config/msp430/msp430.md"

    if (TARGET_LARGE)
      return "SUBA\t#2, r1 { MOVX.A\t2(r1), 0(r1)";
    return "SUB\t#2, r1 { MOV.W\t2(r1), 0(r1)";
  
}

static const char *
output_8 (rtx *operands ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
#line 169 "../../../gcc/gcc/config/msp430/msp430.md"
 return TARGET_LARGE
	   ? "MOVX.A\t0(r1), 2(r1) { ADDA\t#2, SP"
	   : "MOV.W\t0(r1), 2(r1) { ADD\t#2, SP";
  
}

static const char * const output_9[] = {
  "MOV.B\t%1, %0",
  "MOV%X1.B\t%1, %0",
};

static const char *
output_11 (rtx *operands ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  switch (which_alternative)
    {
    case 0: return "MOV.B\t%1, %0";
    case 1:
       return (msp430_430x_insn_not_required (operands[0], operands[1]) ? 	    "MOV.B\t%1, %0" : 	    "MOVX.B\t%1, %0");
      default: gcc_unreachable ();
    }
}

static const char *
output_12 (rtx *operands ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  switch (which_alternative)
    {
    case 0: return "MOV.B\t%1, %0";
    case 1: return "MOV.W\t%1, %0";
    case 2:
       return (msp430_430x_insn_not_required (operands[0], operands[1]) ? 	    "MOV.W\t%1, %0" : 	    "MOVX.W\t%1, %0");
      default: gcc_unreachable ();
    }
}

static const char * const output_15[] = {
  "MOV.B\t%1, %0",
  "MOV.W\t%1, %0",
  "MOVA\t%1, %0",
  "MOVA\t%1, %0",
  "MOVX.A\t%1, %0",
};

static const char * const output_18[] = {
  "ADDA\t%2, %0",
  "ADDX.A\t%2, %0",
};

static const char *
output_19 (rtx *operands ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  switch (which_alternative)
    {
    case 0: return "ADD.B\t%2, %0";
    case 1:
       return (msp430_430x_insn_not_required (operands[0], operands[2]) ? 	     "ADD.B\t%2, %0" : 	     "ADDX.B\t%2, %0");
      default: gcc_unreachable ();
    }
}

static const char *
output_20 (rtx *operands ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  switch (which_alternative)
    {
    case 0: return "ADD.W\t%2, %0";
    case 1:
       return (msp430_430x_insn_not_required (operands[0], operands[2]) ? 	     "ADD.W\t%2, %0" : 	     "ADDX.W\t%2, %0");
      default: gcc_unreachable ();
    }
}

static const char *
output_22 (rtx *operands ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  switch (which_alternative)
    {
    case 0: return "ADD\t%L2, %L0 { ADDC\t%H2, %H0";
    case 1:
       return (msp430_430x_insn_not_required (operands[0], operands[2]) ? 	     "ADD\t%L2, %L0 { ADDC\t%H2, %H0" : 	     "ADDX\t%L2, %L0 { ADDCX\t%H2, %H0");
      default: gcc_unreachable ();
    }
}

static const char *
output_23 (rtx *operands ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  switch (which_alternative)
    {
    case 0: return "ADD\t%2, %1 ; cy";
    case 1:
       return (msp430_430x_insn_not_required (operands[0], operands[2]) ? 	     "ADD\t%2, %1 ; cy" : 	     "ADDX\t%2, %1 ; cy");
      default: gcc_unreachable ();
    }
}

static const char * const output_24[] = {
  "ADD\t%2, %1 ; cy",
  "ADD%X0\t%2, %1 ; cy",
};

static const char *
output_25 (rtx *operands ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  switch (which_alternative)
    {
    case 0: return "ADDC\t%2, %1";
    case 1:
       return (msp430_430x_insn_not_required (operands[0], operands[2]) ? 	     "ADDC\t%2, %1" : 	     "ADDCX\t%2, %1");
      default: gcc_unreachable ();
    }
}

static const char * const output_26[] = {
  "SUBA\t%2, %0",
  "SUBX.A\t%2, %0",
  "MOVX.A\t%1, %0 { SUBX.A\t%2, %0",
  "MOVX.A\t%1, %0 { SUBA\t%2, %0",
};

static const char *
output_27 (rtx *operands ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  switch (which_alternative)
    {
    case 0: return "SUB.B\t%2, %0";
    case 1:
       return (msp430_430x_insn_not_required (operands[0], operands[2]) ? 	     "SUB.B\t%2, %0" : 	     "SUBX.B\t%2, %0");
    case 2: return "MOV%X2.B\t%1, %0 { SUB%X2.B\t%2, %0";
    case 3: return "MOV%X0.B\t%1, %0 { SUB%X0.B\t%2, %0";
      default: gcc_unreachable ();
    }
}

static const char *
output_28 (rtx *operands ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  switch (which_alternative)
    {
    case 0: return "SUB.W\t%2, %0";
    case 1:
       return (msp430_430x_insn_not_required (operands[0], operands[2]) ? 	    "SUB.W\t%2, %0" : 	    "SUBX.W\t%2, %0");
    case 2: return "MOV%X2.W\t%1, %0 { SUB%X2.W\t%2, %0";
    case 3: return "MOV%X0.W\t%1, %0 { SUB%X0.W\t%2, %0";
      default: gcc_unreachable ();
    }
}

static const char *
output_29 (rtx *operands ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
#line 508 "../../../gcc/gcc/config/msp430/msp430.md"

  return (msp430_430x_insn_not_required (operands[0], operands[2]) ? 	  "SUB\t%L2, %L0 { SUBC\t%H2, %H0" : 	  "SUBX\t%L2, %L0 { SUBCX\t%H2, %H0");
}

static const char * const output_30[] = {
  "BIC%x0%b0\t#%I2, %0",
  "BIC%X0%b0\t#%I2, %0",
};

static const char * const output_31[] = {
  "BIC%x0%b0\t#%I2, %0",
  "BIC%X0%b0\t#%I2, %0",
};

static const char * const output_32[] = {
  "BIC%x0%b0\t#%I2, %0",
  "BIC%X0%b0\t#%I2, %0",
};

static const char *
output_33 (rtx *operands ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  switch (which_alternative)
    {
    case 0: return "BIC%x0%b0\t%1, %0";
    case 1:
       return (msp430_430x_insn_not_required (operands[0], operands[1]) ? 	     "BIC%b0\t%1, %0" : 	     "BICX%b0\t%1, %0");
      default: gcc_unreachable ();
    }
}

static const char *
output_34 (rtx *operands ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  switch (which_alternative)
    {
    case 0: return "BIC%x0%b0\t%1, %0";
    case 1:
       return (msp430_430x_insn_not_required (operands[0], operands[1]) ? 	     "BIC%b0\t%1, %0" : 	     "BICX%b0\t%1, %0");
      default: gcc_unreachable ();
    }
}

static const char *
output_35 (rtx *operands ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  switch (which_alternative)
    {
    case 0: return "BIC%x0%b0\t%1, %0";
    case 1:
       return (msp430_430x_insn_not_required (operands[0], operands[1]) ? 	     "BIC%b0\t%1, %0" : 	     "BICX%b0\t%1, %0");
      default: gcc_unreachable ();
    }
}

static const char *
output_36 (rtx *operands ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  switch (which_alternative)
    {
    case 0: return "AND%x0.B\t%2, %0";
    case 1: return "AND%x0%b0\t%2, %0";
    case 2:
       return (msp430_430x_insn_not_required (operands[0], operands[2]) ? 	     "AND%b0\t%2, %0" : 	     "ANDX%b0\t%2, %0");
      default: gcc_unreachable ();
    }
}

static const char *
output_37 (rtx *operands ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  switch (which_alternative)
    {
    case 0: return "AND%x0.B\t%2, %0";
    case 1: return "AND%x0%b0\t%2, %0";
    case 2:
       return (msp430_430x_insn_not_required (operands[0], operands[2]) ? 	     "AND%b0\t%2, %0" : 	     "ANDX%b0\t%2, %0");
      default: gcc_unreachable ();
    }
}

static const char *
output_38 (rtx *operands ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  switch (which_alternative)
    {
    case 0: return "AND%x0.B\t%2, %0";
    case 1: return "AND%x0%b0\t%2, %0";
    case 2:
       return (msp430_430x_insn_not_required (operands[0], operands[2]) ? 	     "AND%b0\t%2, %0" : 	     "ANDX%b0\t%2, %0");
      default: gcc_unreachable ();
    }
}

static const char *
output_39 (rtx *operands ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  switch (which_alternative)
    {
    case 0: return "BIS%x0%b0\t%2, %0";
    case 1:
       return (msp430_430x_insn_not_required (operands[0], operands[2]) ? 	     "BIS%b0\t%2, %0" : 	     "BISX%b0\t%2, %0");
      default: gcc_unreachable ();
    }
}

static const char *
output_40 (rtx *operands ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  switch (which_alternative)
    {
    case 0: return "BIS%x0%b0\t%2, %0";
    case 1:
       return (msp430_430x_insn_not_required (operands[0], operands[2]) ? 	     "BIS%b0\t%2, %0" : 	     "BISX%b0\t%2, %0");
      default: gcc_unreachable ();
    }
}

static const char *
output_41 (rtx *operands ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  switch (which_alternative)
    {
    case 0: return "BIS%x0%b0\t%2, %0";
    case 1:
       return (msp430_430x_insn_not_required (operands[0], operands[2]) ? 	     "BIS%b0\t%2, %0" : 	     "BISX%b0\t%2, %0");
      default: gcc_unreachable ();
    }
}

static const char *
output_42 (rtx *operands ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  switch (which_alternative)
    {
    case 0: return "XOR%x0%b0\t%2, %0";
    case 1:
       return (msp430_430x_insn_not_required (operands[0], operands[2]) ? 	     "XOR%b0\t%2, %0" : 	     "XORX%b0\t%2, %0");
      default: gcc_unreachable ();
    }
}

static const char *
output_43 (rtx *operands ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  switch (which_alternative)
    {
    case 0: return "XOR%x0%b0\t%2, %0";
    case 1:
       return (msp430_430x_insn_not_required (operands[0], operands[2]) ? 	     "XOR%b0\t%2, %0" : 	     "XORX%b0\t%2, %0");
      default: gcc_unreachable ();
    }
}

static const char *
output_44 (rtx *operands ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  switch (which_alternative)
    {
    case 0: return "XOR%x0%b0\t%2, %0";
    case 1:
       return (msp430_430x_insn_not_required (operands[0], operands[2]) ? 	     "XOR%b0\t%2, %0" : 	     "XORX%b0\t%2, %0");
      default: gcc_unreachable ();
    }
}

static const char * const output_45[] = {
  "INV%x0%b0\t%0",
  "INV%X0%b0\t%0",
};

static const char * const output_46[] = {
  "INV%x0%b0\t%0",
  "INV%X0%b0\t%0",
};

static const char * const output_47[] = {
  "INV%x0%b0\t%0",
  "INV%X0%b0\t%0",
};

static const char * const output_48[] = {
  "SXT%X0\t%0",
  "SXT%X0\t%0",
};

static const char * const output_49[] = {
  "AND\t#0xff, %0",
  "MOV.B\t%1, %0",
  "MOV%X1.B\t%1, %0",
  "AND%X0\t#0xff, %0",
};

static const char * const output_50[] = {
  "MOVX\t%1, %0",
  "MOVX.A\t%1, %0",
};

static const char *
output_52 (rtx *operands ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
#line 634 "../../../gcc/gcc/config/msp430/msp430.md"
{ return msp430x_extendhisi (operands); }
}

static const char *
output_55 (rtx *operands ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  switch (which_alternative)
    {
    case 0:
       return (msp430_430x_insn_not_required (operands[0], operands[1]) ?     "MOV.W\t#0,%H0" :     "MOVX.W\t#0,%H0");
    case 1: return "MOV.W\t%1,%L0 { MOV.W\t#0,%H0";
      default: gcc_unreachable ();
    }
}

static const char * const output_56[] = {
  "AND.W\t#-1,%0",
  "MOV.W\t%1,%0",
};

static const char *
output_59 (rtx *operands ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
#line 714 "../../../gcc/gcc/config/msp430/msp430.md"

    if (REGNO (operands[1]) == SP_REGNO)
      /* If the source register is the stack pointer, the value
         stored in the stack slot will be the value *after* the
	 stack pointer has been decremented.  So allow for that
	 here.  */
      return "PUSHM.A\t#1, %1 { ADDX.W\t#4, @r1 { POPX.W\t%L0 { POPX.W\t%H0 ; get stack pointer into %L0:%H0";
    else
      return "PUSHM.A\t#1, %1 { POPX.W\t%L0 { POPX.W\t%H0 ; move pointer in %1 into reg-pair %L0:%H0";
  
}

static const char *
output_60 (rtx *operands ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
#line 734 "../../../gcc/gcc/config/msp430/msp430.md"

    /* The intention here is that we copy the bottom 16-bits of
       %1 into %L0 (zeroing the top four bits).  Then we copy the
       entire 20-bits of %1 into %H0 and then arithmetically shift
       it right by 16 bits, to get the top four bits of the pointer
       sign-extended in %H0.  */
    if (REGNO (operands[0]) == REGNO (operands[1]))
      return "MOVX.A\t%1, %H0 { MOV.W\t%1, %L0 { RPT\t#16 { RRAX.A\t%H0 ; sign extend pointer in %1 into %L0:%H0";
    else
      return "MOV.W\t%1, %L0 { MOVX.A\t%1, %H0 { RPT\t#16 { RRAX.A\t%H0 ; sign extend pointer in %1 into %L0:%H0";
  
}

static const char *
output_63 (rtx *operands ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
#line 824 "../../../gcc/gcc/config/msp430/msp430.md"

  if (INTVAL (operands[2]) > 0 && INTVAL (operands[2]) < 16)
    return "rpt\t%2 { rlax.w\t%0";
  return "# nop left shift";
  
}

static const char *
output_67 (rtx *operands ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
#line 912 "../../../gcc/gcc/config/msp430/msp430.md"

  if (INTVAL (operands[2]) > 0 && INTVAL (operands[2]) < 16)
    return "rpt\t%2 { rrax.w\t%0";
  return "# nop arith right shift";
  
}

static const char *
output_73 (rtx *operands ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
#line 1015 "../../../gcc/gcc/config/msp430/msp430.md"
{
    return msp430x_logical_shift_right (operands[2]);
  }
}

static const char *
output_84 (rtx *operands ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
#line 1151 "../../../gcc/gcc/config/msp430/msp430.md"
{ return msp430_is_interrupt_func () ? "RETI" : (TARGET_LARGE ? "RETA" : "RET"); }
}

static const char * const output_88[] = {
  "CMP%Q0\t%2, %1 { J%0\t%l3",
  "CMPX.A\t%2, %1 { J%0\t%l3",
  "CMPX.A\t%2, %1 { J%0\t%l3",
};

static const char *
output_89 (rtx *operands ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  switch (which_alternative)
    {
    case 0: return "CMP.B\t%2, %1 { J%0\t%l3";
    case 1:
       return (msp430_430x_insn_not_required (operands[1], operands[2]) ? 	     "CMP.B\t%2, %1 { J%0\t%l3" : 	     "CMPX.B\t%2, %1 { J%0\t%l3");
      default: gcc_unreachable ();
    }
}

static const char *
output_90 (rtx *operands ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
#line 1254 "../../../gcc/gcc/config/msp430/msp430.md"

    /* This is nasty.  If we are splitting code between low and high memory
       then we do not want the linker to increase the size of sections by
       relaxing out of range jump instructions.  (Since relaxation occurs
       after section placement).  So we have to generate pessimal branches
       here.  But we only want to do this when really necessary.

       FIXME: Do we need code in the other cbranch patterns ?  */
    if (msp430_do_not_relax_short_jumps () && get_attr_length (insn) > 6)
      {
        return which_alternative == 0 ?
            "CMP.W\t%2, %1 { J%r0 1f { BRA #%l3 { 1:" :
	    (msp430_430x_insn_not_required (operands[1], operands[2]) ?
	     "CMP.W\t%2, %1 { J%r0 1f { BRA #%l3 { 1:" :
	     "CMPX.W\t%2, %1 { J%r0 1f { BRA #%l3 { 1:");
      }

    return which_alternative == 0 ?
         "CMP.W\t%2, %1 { J%0\t%l3" :
	 (msp430_430x_insn_not_required (operands[1], operands[2]) ?
	  "CMP.W\t%2, %1 { J%0\t%l3" :
	  "CMPX.W\t%2, %1 { J%0\t%l3");
  
}

static const char * const output_91[] = {
  "CMP%Q0\t%1, %2 { J%R0\t%l3",
  "CMPX.A\t%1, %2 { J%R0\t%l3",
  "CMPX.A\t%1, %2 { J%R0\t%l3",
};

static const char *
output_92 (rtx *operands ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  switch (which_alternative)
    {
    case 0: return "CMP.B\t%1, %2 { J%R0\t%l3";
    case 1:
       return (msp430_430x_insn_not_required (operands[1], operands[2]) ? 	     "CMP.B\t%1, %2 { J%R0\t%l3" : 	     "CMPX.B\t%1, %2 { J%R0\t%l3");
      default: gcc_unreachable ();
    }
}

static const char *
output_93 (rtx *operands ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  switch (which_alternative)
    {
    case 0: return "CMP.W\t%1, %2 { J%R0\t%l3";
    case 1:
       return (msp430_430x_insn_not_required (operands[1], operands[2]) ? 	     "CMP.W\t%1, %2 { J%R0\t%l3" : 	     "CMPX.W\t%1, %2 { J%R0\t%l3");
      default: gcc_unreachable ();
    }
}

static const char *
output_94 (rtx *operands ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  switch (which_alternative)
    {
    case 0: return "BIT%x0%b0\t%1, %0 { JNE\t%l2";
    case 1:
       return (msp430_430x_insn_not_required (operands[0], operands[1]) ? 	     "BIT%b0\t%1, %0 { JNE\t%l2" : 	     "BITX%b0\t%1, %0 { JNE\t%l2");
      default: gcc_unreachable ();
    }
}

static const char *
output_95 (rtx *operands ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  switch (which_alternative)
    {
    case 0: return "BIT%x0%b0\t%1, %0 { JNE\t%l2";
    case 1:
       return (msp430_430x_insn_not_required (operands[0], operands[1]) ? 	     "BIT%b0\t%1, %0 { JNE\t%l2" : 	     "BITX%b0\t%1, %0 { JNE\t%l2");
      default: gcc_unreachable ();
    }
}

static const char *
output_96 (rtx *operands ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  switch (which_alternative)
    {
    case 0: return "BIT%x0%b0\t%1, %0 { JNE\t%l2";
    case 1:
       return (msp430_430x_insn_not_required (operands[0], operands[1]) ? 	     "BIT%b0\t%1, %0 { JNE\t%l2" : 	     "BITX%b0\t%1, %0 { JNE\t%l2");
      default: gcc_unreachable ();
    }
}

static const char *
output_97 (rtx *operands ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
#line 1363 "../../../gcc/gcc/config/msp430/msp430.md"

   return (msp430_430x_insn_not_required (operands[0], operands[1]) ? 	     "BIT%b0\t%1, %0 { JEQ\t%l2" : 	     "BITX%b0\t%1, %0 { JEQ\t%l2");
}

static const char *
output_98 (rtx *operands ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
#line 1363 "../../../gcc/gcc/config/msp430/msp430.md"

   return (msp430_430x_insn_not_required (operands[0], operands[1]) ? 	     "BIT%b0\t%1, %0 { JEQ\t%l2" : 	     "BITX%b0\t%1, %0 { JEQ\t%l2");
}

static const char *
output_99 (rtx *operands ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
#line 1363 "../../../gcc/gcc/config/msp430/msp430.md"

   return (msp430_430x_insn_not_required (operands[0], operands[1]) ? 	     "BIT%b0\t%1, %0 { JEQ\t%l2" : 	     "BITX%b0\t%1, %0 { JEQ\t%l2");
}

static const char *
output_100 (rtx *operands ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
#line 1379 "../../../gcc/gcc/config/msp430/msp430.md"

  return (msp430_430x_insn_not_required (operands[0], operands[1]) ? 	  "BIT%b0\t%1, %0 { JNE\t%l2" : 	  "BITX%b0\t%1, %0 { JNE\t%l2");
}

static const char *
output_101 (rtx *operands ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
#line 1379 "../../../gcc/gcc/config/msp430/msp430.md"

  return (msp430_430x_insn_not_required (operands[0], operands[1]) ? 	  "BIT%b0\t%1, %0 { JNE\t%l2" : 	  "BITX%b0\t%1, %0 { JNE\t%l2");
}

static const char *
output_102 (rtx *operands ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
#line 1379 "../../../gcc/gcc/config/msp430/msp430.md"

  return (msp430_430x_insn_not_required (operands[0], operands[1]) ? 	  "BIT%b0\t%1, %0 { JNE\t%l2" : 	  "BITX%b0\t%1, %0 { JNE\t%l2");
}

static const char *
output_103 (rtx *operands ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
#line 1395 "../../../gcc/gcc/config/msp430/msp430.md"

  return (msp430_430x_insn_not_required (operands[0], operands[1]) ? 	  "BIT%b0\t%1, %0 { JEQ\t%l2" : 	  "BITX%b0\t%1, %0 { JEQ\t%l2");
}

static const char *
output_104 (rtx *operands ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
#line 1395 "../../../gcc/gcc/config/msp430/msp430.md"

  return (msp430_430x_insn_not_required (operands[0], operands[1]) ? 	  "BIT%b0\t%1, %0 { JEQ\t%l2" : 	  "BITX%b0\t%1, %0 { JEQ\t%l2");
}

static const char *
output_105 (rtx *operands ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
#line 1395 "../../../gcc/gcc/config/msp430/msp430.md"

  return (msp430_430x_insn_not_required (operands[0], operands[1]) ? 	  "BIT%b0\t%1, %0 { JEQ\t%l2" : 	  "BITX%b0\t%1, %0 { JEQ\t%l2");
}

static const char * const output_106[] = {
  "BIT%x0%b0\t%p1, %0 { JNE\t%l2",
  "BIT%X0%b0\t%p1, %0 { JNE\t%l2",
};

static const char * const output_107[] = {
  "BIT%x0%b0\t%p1, %0 { JNE\t%l2",
  "BIT%X0%b0\t%p1, %0 { JNE\t%l2",
};

static const char * const output_108[] = {
  "BIT%x0%b0\t%p1, %0 { JNE\t%l2",
  "BIT%X0%b0\t%p1, %0 { JNE\t%l2",
};

static const char *
output_125 (rtx *operands ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
#line 1519 "../../../gcc/gcc/config/msp430/msp430.md"

    if (REGNO (operands[0]) != REGNO (operands[1]))
      return "MOV.W\t%1, %0 { INV.W\t%0 { INC.W\t%0 { AND.W\t%2, %0";
    else
      return "INV.W\t%0 { INC.W\t%0 { AND.W\t%2, %0";
  
}

static const char *
output_134 (rtx *operands ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
#line 1616 "../../../gcc/gcc/config/msp430/msp430.md"

    if (msp430_use_f5_series_hwmult ())
      return "PUSH.W sr { DINT { NOP { MOV.W %1, &0x04C2 { MOV.W %2, &0x04C8 { MOV.W &0x04CA, %L0 { MOV.W &0x04CC, %H0 { POP.W sr";
    else
      return "PUSH.W sr { DINT { NOP { MOV.W %1, &0x0132 { MOV.W %2, &0x0138 { MOV.W &0x013A, %L0 { MOV.W &0x013C, %H0 { POP.W sr";
  
}

static const char *
output_135 (rtx *operands ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
#line 1629 "../../../gcc/gcc/config/msp430/msp430.md"

    if (msp430_use_f5_series_hwmult ())
      return "PUSH.W sr { DINT { NOP { MOV.W %1, &0x04C0 { MOV.W %2, &0x04C8 { MOV.W &0x04CA, %L0 { MOV.W &0x04CC, %H0 { POP.W sr";
    else
      return "PUSH.W sr { DINT { NOP { MOV.W %1, &0x0130 { MOV.W %2, &0x0138 { MOV.W &0x013A, %L0 { MOV.W &0x013C, %H0 { POP.W sr";
  
}

static const char *
output_136 (rtx *operands ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
#line 1642 "../../../gcc/gcc/config/msp430/msp430.md"

    if (msp430_use_f5_series_hwmult ())
      return "PUSH.W sr { DINT { NOP { MOV.W %L1, &0x04D4 { MOV.W %H1, &0x04D6 { MOV.W %L2, &0x04E0 { MOV.W %H2, &0x04E2 { MOV.W &0x04E4, %A0 { MOV.W &0x04E6, %B0 { MOV.W &0x04E8, %C0 { MOV.W &0x04EA, %D0 { POP.W sr";
    else
      return "PUSH.W sr { DINT { NOP { MOV.W %L1, &0x0144 { MOV.W %H1, &0x0146 { MOV.W %L2, &0x0150 { MOV.W %H2, &0x0152 { MOV.W &0x0154, %A0 { MOV.W &0x0156, %B0 { MOV.W &0x0158, %C0 { MOV.W &0x015A, %D0 { POP.W sr";
  
}

static const char *
output_137 (rtx *operands ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
#line 1655 "../../../gcc/gcc/config/msp430/msp430.md"

    if (msp430_use_f5_series_hwmult ())
      return "PUSH.W sr { DINT { NOP { MOV.W %L1, &0x04D0 { MOV.W %H1, &0x04D2 { MOV.W %L2, &0x04E0 { MOV.W %H2, &0x04E2 { MOV.W &0x04E4, %A0 { MOV.W &0x04E6, %B0 { MOV.W &0x04E8, %C0 { MOV.W &0x04EA, %D0 { POP.W sr";
    else
      return "PUSH.W sr { DINT { NOP { MOV.W %L1, &0x0140 { MOV.W %H1, &0x0142 { MOV.W %L2, &0x0150 { MOV.W %H2, &0x0152 { MOV.W &0x0154, %A0 { MOV.W &0x0156, %B0 { MOV.W &0x0158, %C0 { MOV.W &0x015A, %D0 { POP.W sr";
  
}



static const struct insn_operand_data operand_data[] = 
{
  {
    0,
    "",
    E_VOIDmode,
    0,
    0,
    0,
    0
  },
  {
    register_operand,
    "r",
    E_HImode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "r",
    E_PSImode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "r",
    E_VOIDmode,
    0,
    0,
    1,
    0
  },
  {
    immediate_operand,
    "n",
    E_VOIDmode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "=r",
    E_HImode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "=r",
    E_PSImode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "r",
    E_VOIDmode,
    0,
    0,
    1,
    0
  },
  {
    immediate_operand,
    "i",
    E_VOIDmode,
    0,
    0,
    1,
    0
  },
  {
    immediate_operand,
    "i",
    E_VOIDmode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "=r,r",
    E_HImode,
    0,
    0,
    1,
    0
  },
  {
    memory_operand,
    "Ys,m",
    E_QImode,
    0,
    0,
    1,
    1
  },
  {
    msp_nonimmediate_operand,
    "=r",
    E_QImode,
    0,
    0,
    1,
    1
  },
  {
    msp_general_operand,
    "r",
    E_PSImode,
    0,
    0,
    1,
    1
  },
  {
    msp_nonimmediate_operand,
    "=rYs,rm",
    E_QImode,
    0,
    0,
    1,
    1
  },
  {
    msp_general_operand,
    "riYs,rmi",
    E_QImode,
    0,
    0,
    1,
    1
  },
  {
    msp_nonimmediate_operand,
    "=r,rYs,rm",
    E_HImode,
    0,
    0,
    1,
    1
  },
  {
    msp_general_operand,
    "N,riYs,rmi",
    E_HImode,
    0,
    0,
    1,
    1
  },
  {
    nonimmediate_operand,
    "=rm",
    E_SImode,
    0,
    0,
    1,
    1
  },
  {
    msp430_symbol_operand,
    "i",
    E_PSImode,
    0,
    0,
    1,
    0
  },
  {
    nonimmediate_operand,
    "=rm",
    E_SImode,
    0,
    0,
    1,
    1
  },
  {
    general_operand,
    "rmi",
    E_SImode,
    0,
    0,
    1,
    1
  },
  {
    msp_nonimmediate_operand,
    "=r,r,r,Ya,rm",
    E_PSImode,
    0,
    0,
    1,
    1
  },
  {
    msp_general_operand,
    "N,O,riYa,r,rmi",
    E_PSImode,
    0,
    0,
    1,
    1
  },
  {
    register_operand,
    "=r",
    E_PSImode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "r",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "=r",
    E_HImode,
    0,
    0,
    1,
    0
  },
  {
    msp430_symbol_operand,
    "i",
    E_PSImode,
    0,
    0,
    1,
    0
  },
  {
    msp_nonimmediate_operand,
    "=r,rm",
    E_PSImode,
    0,
    0,
    1,
    1
  },
  {
    msp_nonimmediate_operand,
    "%0,0",
    E_PSImode,
    0,
    0,
    1,
    1
  },
  {
    msp_general_operand,
    "rLs,rmi",
    E_PSImode,
    0,
    0,
    1,
    1
  },
  {
    msp_nonimmediate_operand,
    "=rYs,rm",
    E_QImode,
    0,
    0,
    1,
    1
  },
  {
    msp_nonimmediate_operand,
    "%0,0",
    E_QImode,
    0,
    0,
    1,
    1
  },
  {
    msp_general_operand,
    "riYs,rmi",
    E_QImode,
    0,
    0,
    1,
    1
  },
  {
    msp_nonimmediate_operand,
    "=rYs,rm",
    E_HImode,
    0,
    0,
    1,
    1
  },
  {
    msp_nonimmediate_operand,
    "%0,0",
    E_HImode,
    0,
    0,
    1,
    1
  },
  {
    msp_general_operand,
    "riYs,rmi",
    E_HImode,
    0,
    0,
    1,
    1
  },
  {
    register_operand,
    "=&r",
    E_PSImode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "0",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    general_operand,
    "rmi",
    E_VOIDmode,
    0,
    0,
    1,
    1
  },
  {
    nonimmediate_operand,
    "=&r,rm",
    E_SImode,
    0,
    0,
    1,
    1
  },
  {
    nonimmediate_operand,
    "%0,0",
    E_SImode,
    0,
    0,
    1,
    1
  },
  {
    general_operand,
    "r,mi",
    E_SImode,
    0,
    0,
    1,
    1
  },
  {
    msp_nonimmediate_operand,
    "=r,rm",
    E_HImode,
    0,
    0,
    1,
    1
  },
  {
    msp_nonimmediate_operand,
    "%0,0",
    E_HImode,
    0,
    0,
    1,
    1
  },
  {
    msp_nonimmediate_operand,
    "r,rm",
    E_HImode,
    0,
    0,
    1,
    1
  },
  {
    nonimmediate_operand,
    "=r,rm",
    E_HImode,
    0,
    0,
    1,
    1
  },
  {
    nonimmediate_operand,
    "%0,0",
    E_HImode,
    0,
    0,
    1,
    1
  },
  {
    immediate_operand,
    "i,i",
    E_HImode,
    0,
    0,
    1,
    0
  },
  {
    immediate_operand,
    "i,i",
    E_VOIDmode,
    0,
    0,
    1,
    0
  },
  {
    msp_nonimmediate_operand,
    "=r,rm",
    E_HImode,
    0,
    0,
    1,
    1
  },
  {
    msp_nonimmediate_operand,
    "%0,0",
    E_HImode,
    0,
    0,
    1,
    1
  },
  {
    msp_general_operand,
    "ri,rmi",
    E_HImode,
    0,
    0,
    1,
    1
  },
  {
    nonimmediate_operand,
    "=r,rm,&?r,?&r",
    E_PSImode,
    0,
    0,
    1,
    1
  },
  {
    general_operand,
    "0,0,!r,!i",
    E_PSImode,
    0,
    0,
    1,
    1
  },
  {
    general_operand,
    "rLs,rmi,rmi,r",
    E_PSImode,
    0,
    0,
    1,
    1
  },
  {
    nonimmediate_operand,
    "=rYs,rm,&?r,?&r",
    E_QImode,
    0,
    0,
    1,
    1
  },
  {
    general_operand,
    "0,0,!r,!i",
    E_QImode,
    0,
    0,
    1,
    1
  },
  {
    general_operand,
    "riYs,rmi,rmi,r",
    E_QImode,
    0,
    0,
    1,
    1
  },
  {
    nonimmediate_operand,
    "=rYs,rm,&?r,?&r",
    E_HImode,
    0,
    0,
    1,
    1
  },
  {
    general_operand,
    "0,0,!r,!i",
    E_HImode,
    0,
    0,
    1,
    1
  },
  {
    general_operand,
    "riYs,rmi,rmi,r",
    E_HImode,
    0,
    0,
    1,
    1
  },
  {
    nonimmediate_operand,
    "=&rm",
    E_SImode,
    0,
    0,
    1,
    1
  },
  {
    nonimmediate_operand,
    "0",
    E_SImode,
    0,
    0,
    1,
    1
  },
  {
    general_operand,
    "rmi",
    E_SImode,
    0,
    0,
    1,
    1
  },
  {
    msp_nonimmediate_operand,
    "=rYs,m",
    E_QImode,
    0,
    0,
    1,
    1
  },
  {
    msp_general_operand,
    "0,0",
    E_QImode,
    0,
    0,
    1,
    1
  },
  {
    msp430_inv_constgen_operator,
    "n,n",
    E_VOIDmode,
    0,
    0,
    1,
    0
  },
  {
    msp_nonimmediate_operand,
    "=rYs,m",
    E_HImode,
    0,
    0,
    1,
    1
  },
  {
    msp_general_operand,
    "0,0",
    E_HImode,
    0,
    0,
    1,
    1
  },
  {
    msp430_inv_constgen_operator,
    "n,n",
    E_VOIDmode,
    0,
    0,
    1,
    0
  },
  {
    msp_nonimmediate_operand,
    "=rYs,m",
    E_PSImode,
    0,
    0,
    1,
    1
  },
  {
    msp_general_operand,
    "0,0",
    E_PSImode,
    0,
    0,
    1,
    1
  },
  {
    msp430_inv_constgen_operator,
    "n,n",
    E_VOIDmode,
    0,
    0,
    1,
    0
  },
  {
    msp_nonimmediate_operand,
    "=rYs,rm",
    E_QImode,
    0,
    0,
    1,
    1
  },
  {
    msp_general_operand,
    "rYs,rmn",
    E_QImode,
    0,
    0,
    1,
    1
  },
  {
    msp_nonimmediate_operand,
    "0,0",
    E_QImode,
    0,
    0,
    1,
    1
  },
  {
    msp_nonimmediate_operand,
    "=rYs,rm",
    E_HImode,
    0,
    0,
    1,
    1
  },
  {
    msp_general_operand,
    "rYs,rmn",
    E_HImode,
    0,
    0,
    1,
    1
  },
  {
    msp_nonimmediate_operand,
    "0,0",
    E_HImode,
    0,
    0,
    1,
    1
  },
  {
    msp_nonimmediate_operand,
    "=rYs,rm",
    E_PSImode,
    0,
    0,
    1,
    1
  },
  {
    msp_general_operand,
    "rYs,rmn",
    E_PSImode,
    0,
    0,
    1,
    1
  },
  {
    msp_nonimmediate_operand,
    "0,0",
    E_PSImode,
    0,
    0,
    1,
    1
  },
  {
    msp_nonimmediate_operand,
    "=r,rYs,rm",
    E_QImode,
    0,
    0,
    1,
    1
  },
  {
    msp_nonimmediate_operand,
    "%0,0,0",
    E_QImode,
    0,
    0,
    1,
    1
  },
  {
    msp_general_operand,
    "N,riYs,rmi",
    E_QImode,
    0,
    0,
    1,
    1
  },
  {
    msp_nonimmediate_operand,
    "=r,rYs,rm",
    E_HImode,
    0,
    0,
    1,
    1
  },
  {
    msp_nonimmediate_operand,
    "%0,0,0",
    E_HImode,
    0,
    0,
    1,
    1
  },
  {
    msp_general_operand,
    "N,riYs,rmi",
    E_HImode,
    0,
    0,
    1,
    1
  },
  {
    msp_nonimmediate_operand,
    "=r,rYs,rm",
    E_PSImode,
    0,
    0,
    1,
    1
  },
  {
    msp_nonimmediate_operand,
    "%0,0,0",
    E_PSImode,
    0,
    0,
    1,
    1
  },
  {
    msp_general_operand,
    "N,riYs,rmi",
    E_PSImode,
    0,
    0,
    1,
    1
  },
  {
    msp_nonimmediate_operand,
    "=rYs,rm",
    E_PSImode,
    0,
    0,
    1,
    1
  },
  {
    msp_nonimmediate_operand,
    "%0,0",
    E_PSImode,
    0,
    0,
    1,
    1
  },
  {
    msp_general_operand,
    "riYs,rmi",
    E_PSImode,
    0,
    0,
    1,
    1
  },
  {
    msp_nonimmediate_operand,
    "=rYs,m",
    E_QImode,
    0,
    0,
    1,
    1
  },
  {
    msp_nonimmediate_operand,
    "0,0",
    E_QImode,
    0,
    0,
    1,
    1
  },
  {
    msp_nonimmediate_operand,
    "=rYs,m",
    E_HImode,
    0,
    0,
    1,
    1
  },
  {
    msp_nonimmediate_operand,
    "0,0",
    E_HImode,
    0,
    0,
    1,
    1
  },
  {
    msp_nonimmediate_operand,
    "=rYs,m",
    E_PSImode,
    0,
    0,
    1,
    1
  },
  {
    msp_nonimmediate_operand,
    "0,0",
    E_PSImode,
    0,
    0,
    1,
    1
  },
  {
    msp_nonimmediate_operand,
    "=rYs,m",
    E_HImode,
    0,
    0,
    1,
    1
  },
  {
    msp_nonimmediate_operand,
    "0,0",
    E_QImode,
    0,
    0,
    1,
    1
  },
  {
    msp_nonimmediate_operand,
    "=rYs,r,r,m",
    E_HImode,
    0,
    0,
    1,
    1
  },
  {
    msp_nonimmediate_operand,
    "0,rYs,m,0",
    E_QImode,
    0,
    0,
    1,
    1
  },
  {
    msp_nonimmediate_operand,
    "=r,m",
    E_PSImode,
    0,
    0,
    1,
    1
  },
  {
    msp_nonimmediate_operand,
    "rm,r",
    E_HImode,
    0,
    0,
    1,
    1
  },
  {
    msp_nonimmediate_operand,
    "=rm",
    E_HImode,
    0,
    0,
    1,
    1
  },
  {
    register_operand,
    "r",
    E_PSImode,
    0,
    0,
    1,
    0
  },
  {
    nonimmediate_operand,
    "=r",
    E_SImode,
    0,
    0,
    1,
    1
  },
  {
    nonimmediate_operand,
    "r",
    E_HImode,
    0,
    0,
    1,
    1
  },
  {
    nonimmediate_operand,
    "=r",
    E_PSImode,
    0,
    0,
    1,
    1
  },
  {
    nonimmediate_operand,
    "0",
    E_HImode,
    0,
    0,
    1,
    1
  },
  {
    nonimmediate_operand,
    "=r",
    E_SImode,
    0,
    0,
    1,
    1
  },
  {
    nonimmediate_operand,
    "rm",
    E_QImode,
    0,
    0,
    1,
    1
  },
  {
    nonimmediate_operand,
    "=rm,r",
    E_SImode,
    0,
    0,
    1,
    1
  },
  {
    nonimmediate_operand,
    "0,r",
    E_HImode,
    0,
    0,
    1,
    1
  },
  {
    nonimmediate_operand,
    "=r,r",
    E_PSImode,
    0,
    0,
    1,
    1
  },
  {
    nonimmediate_operand,
    "0,r",
    E_HImode,
    0,
    0,
    1,
    1
  },
  {
    register_operand,
    "+r",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "r",
    E_PSImode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "=r",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "r",
    E_PSImode,
    0,
    0,
    1,
    0
  },
  {
    nonimmediate_operand,
    "=rm",
    E_HImode,
    0,
    0,
    1,
    1
  },
  {
    general_operand,
    "0",
    E_HImode,
    0,
    0,
    1,
    1
  },
  {
    register_operand,
    "=r",
    E_HImode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "0",
    E_HImode,
    0,
    0,
    1,
    0
  },
  {
    immediate_operand,
    "n",
    E_VOIDmode,
    0,
    0,
    1,
    0
  },
  {
    nonimmediate_operand,
    "=rm",
    E_SImode,
    0,
    0,
    1,
    1
  },
  {
    general_operand,
    "0",
    E_SImode,
    0,
    0,
    1,
    1
  },
  {
    msp_nonimmediate_operand,
    "=rm",
    E_HImode,
    0,
    0,
    1,
    1
  },
  {
    msp_general_operand,
    "0",
    E_HImode,
    0,
    0,
    1,
    1
  },
  {
    register_operand,
    "=r",
    E_PSImode,
    0,
    0,
    1,
    0
  },
  {
    general_operand,
    "0",
    E_PSImode,
    0,
    0,
    1,
    1
  },
  {
    nonimmediate_operand,
    "=r",
    E_SImode,
    0,
    0,
    1,
    1
  },
  {
    general_operand,
    "0",
    E_SImode,
    0,
    0,
    1,
    1
  },
  {
    general_operand,
    "rYci",
    E_VOIDmode,
    0,
    0,
    1,
    1
  },
  {
    0,
    "",
    E_VOIDmode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "=r",
    E_VOIDmode,
    0,
    0,
    1,
    0
  },
  {
    general_operand,
    "rYci",
    E_VOIDmode,
    0,
    0,
    1,
    1
  },
  {
    0,
    "",
    E_VOIDmode,
    0,
    0,
    1,
    0
  },
  {
    nonimmediate_operand,
    "rYl",
    E_VOIDmode,
    0,
    0,
    1,
    1
  },
  {
    msp430_cmp_operator,
    "",
    E_VOIDmode,
    0,
    1,
    0,
    0
  },
  {
    nonimmediate_operand,
    "r,rYs,rm",
    E_PSImode,
    0,
    0,
    1,
    1
  },
  {
    general_operand,
    "rLs,rYsi,rmi",
    E_PSImode,
    0,
    0,
    1,
    1
  },
  {
    0,
    "",
    E_VOIDmode,
    0,
    0,
    1,
    0
  },
  {
    msp430_cmp_operator,
    "",
    E_VOIDmode,
    0,
    1,
    0,
    0
  },
  {
    nonimmediate_operand,
    "rYs,rm",
    E_QImode,
    0,
    0,
    1,
    1
  },
  {
    general_operand,
    "rYsi,rmi",
    E_QImode,
    0,
    0,
    1,
    1
  },
  {
    0,
    "",
    E_VOIDmode,
    0,
    0,
    1,
    0
  },
  {
    msp430_cmp_operator,
    "",
    E_VOIDmode,
    0,
    1,
    0,
    0
  },
  {
    nonimmediate_operand,
    "rYs,rm",
    E_HImode,
    0,
    0,
    1,
    1
  },
  {
    general_operand,
    "rYsi,rmi",
    E_HImode,
    0,
    0,
    1,
    1
  },
  {
    0,
    "",
    E_VOIDmode,
    0,
    0,
    1,
    0
  },
  {
    msp430_reversible_cmp_operator,
    "",
    E_VOIDmode,
    0,
    1,
    0,
    0
  },
  {
    general_operand,
    "rLs,rYsi,rmi",
    E_PSImode,
    0,
    0,
    1,
    1
  },
  {
    general_operand,
    "r,rYs,rm",
    E_PSImode,
    0,
    0,
    1,
    1
  },
  {
    0,
    "",
    E_VOIDmode,
    0,
    0,
    1,
    0
  },
  {
    msp430_reversible_cmp_operator,
    "",
    E_VOIDmode,
    0,
    1,
    0,
    0
  },
  {
    general_operand,
    "rYsi,rmi",
    E_QImode,
    0,
    0,
    1,
    1
  },
  {
    general_operand,
    "rYs,rm",
    E_QImode,
    0,
    0,
    1,
    1
  },
  {
    0,
    "",
    E_VOIDmode,
    0,
    0,
    1,
    0
  },
  {
    msp430_reversible_cmp_operator,
    "",
    E_VOIDmode,
    0,
    1,
    0,
    0
  },
  {
    general_operand,
    "rYsi,rmi",
    E_HImode,
    0,
    0,
    1,
    1
  },
  {
    general_operand,
    "rYs,rm",
    E_HImode,
    0,
    0,
    1,
    1
  },
  {
    0,
    "",
    E_VOIDmode,
    0,
    0,
    1,
    0
  },
  {
    msp_nonimmediate_operand,
    "rYs,rm",
    E_QImode,
    0,
    0,
    1,
    1
  },
  {
    msp_general_operand,
    "rYsi,rmi",
    E_QImode,
    0,
    0,
    1,
    1
  },
  {
    0,
    "",
    E_VOIDmode,
    0,
    0,
    1,
    0
  },
  {
    msp_nonimmediate_operand,
    "rYs,rm",
    E_HImode,
    0,
    0,
    1,
    1
  },
  {
    msp_general_operand,
    "rYsi,rmi",
    E_HImode,
    0,
    0,
    1,
    1
  },
  {
    0,
    "",
    E_VOIDmode,
    0,
    0,
    1,
    0
  },
  {
    msp_nonimmediate_operand,
    "rYs,rm",
    E_PSImode,
    0,
    0,
    1,
    1
  },
  {
    msp_general_operand,
    "rYsi,rmi",
    E_PSImode,
    0,
    0,
    1,
    1
  },
  {
    0,
    "",
    E_VOIDmode,
    0,
    0,
    1,
    0
  },
  {
    msp_nonimmediate_operand,
    "rm",
    E_QImode,
    0,
    0,
    1,
    1
  },
  {
    msp_general_operand,
    "rmi",
    E_QImode,
    0,
    0,
    1,
    1
  },
  {
    0,
    "",
    E_VOIDmode,
    0,
    0,
    1,
    0
  },
  {
    msp_nonimmediate_operand,
    "rm",
    E_HImode,
    0,
    0,
    1,
    1
  },
  {
    msp_general_operand,
    "rmi",
    E_HImode,
    0,
    0,
    1,
    1
  },
  {
    0,
    "",
    E_VOIDmode,
    0,
    0,
    1,
    0
  },
  {
    msp_nonimmediate_operand,
    "rm",
    E_PSImode,
    0,
    0,
    1,
    1
  },
  {
    msp_general_operand,
    "rmi",
    E_PSImode,
    0,
    0,
    1,
    1
  },
  {
    0,
    "",
    E_VOIDmode,
    0,
    0,
    1,
    0
  },
  {
    msp_nonimmediate_operand,
    "rYs,rm",
    E_QImode,
    0,
    0,
    1,
    1
  },
  {
    msp430_bitpos,
    "i,i",
    E_VOIDmode,
    0,
    0,
    1,
    0
  },
  {
    0,
    "",
    E_VOIDmode,
    0,
    0,
    1,
    0
  },
  {
    msp_nonimmediate_operand,
    "rYs,rm",
    E_HImode,
    0,
    0,
    1,
    1
  },
  {
    msp430_bitpos,
    "i,i",
    E_VOIDmode,
    0,
    0,
    1,
    0
  },
  {
    0,
    "",
    E_VOIDmode,
    0,
    0,
    1,
    0
  },
  {
    msp_nonimmediate_operand,
    "rYs,rm",
    E_PSImode,
    0,
    0,
    1,
    1
  },
  {
    msp430_bitpos,
    "i,i",
    E_VOIDmode,
    0,
    0,
    1,
    0
  },
  {
    0,
    "",
    E_VOIDmode,
    0,
    0,
    1,
    0
  },
  {
    msp_nonimmediate_operand,
    "rm",
    E_QImode,
    0,
    0,
    1,
    1
  },
  {
    msp430_bitpos,
    "i",
    E_VOIDmode,
    0,
    0,
    1,
    0
  },
  {
    0,
    "",
    E_VOIDmode,
    0,
    0,
    1,
    0
  },
  {
    msp_nonimmediate_operand,
    "rm",
    E_HImode,
    0,
    0,
    1,
    1
  },
  {
    msp430_bitpos,
    "i",
    E_VOIDmode,
    0,
    0,
    1,
    0
  },
  {
    0,
    "",
    E_VOIDmode,
    0,
    0,
    1,
    0
  },
  {
    msp_nonimmediate_operand,
    "rm",
    E_PSImode,
    0,
    0,
    1,
    1
  },
  {
    msp430_bitpos,
    "i",
    E_VOIDmode,
    0,
    0,
    1,
    0
  },
  {
    0,
    "",
    E_VOIDmode,
    0,
    0,
    1,
    0
  },
  {
    nonmemory_operand,
    "ir",
    E_VOIDmode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "=r",
    E_HImode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "r",
    E_HImode,
    0,
    0,
    1,
    0
  },
  {
    immediate_operand,
    "n",
    E_VOIDmode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "=r",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "%0",
    E_HImode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "r",
    E_HImode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "=r",
    E_DImode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "%0",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "r",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    nonimmediate_operand,
    "",
    E_SImode,
    0,
    0,
    1,
    1
  },
  {
    general_operand,
    "",
    E_SImode,
    0,
    0,
    1,
    1
  },
  {
    nonimmediate_operand,
    "",
    E_HImode,
    0,
    0,
    1,
    1
  },
  {
    general_operand,
    "",
    E_HImode,
    0,
    0,
    1,
    1
  },
  {
    general_operand,
    "",
    E_HImode,
    0,
    0,
    1,
    1
  },
  {
    nonimmediate_operand,
    "",
    E_SImode,
    0,
    0,
    1,
    1
  },
  {
    general_operand,
    "",
    E_SImode,
    0,
    0,
    1,
    1
  },
  {
    general_operand,
    "",
    E_SImode,
    0,
    0,
    1,
    1
  },
  {
    nonimmediate_operand,
    "",
    E_DImode,
    0,
    0,
    1,
    1
  },
  {
    general_operand,
    "",
    E_DImode,
    0,
    0,
    1,
    1
  },
  {
    general_operand,
    "",
    E_DImode,
    0,
    0,
    1,
    1
  },
  {
    0,
    "",
    E_VOIDmode,
    0,
    0,
    1,
    0
  },
  {
    0,
    "",
    E_VOIDmode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "",
    E_VOIDmode,
    0,
    0,
    1,
    0
  },
  {
    general_operand,
    "",
    E_VOIDmode,
    0,
    0,
    1,
    1
  },
  {
    0,
    "",
    E_VOIDmode,
    0,
    0,
    1,
    0
  },
  {
    0,
    "",
    E_HImode,
    0,
    0,
    1,
    0
  },
  {
    0,
    "",
    E_VOIDmode,
    0,
    1,
    0,
    0
  },
  {
    nonimmediate_operand,
    "",
    E_QImode,
    0,
    0,
    1,
    1
  },
  {
    general_operand,
    "",
    E_QImode,
    0,
    0,
    1,
    1
  },
  {
    0,
    "",
    E_VOIDmode,
    0,
    0,
    1,
    0
  },
  {
    0,
    "",
    E_VOIDmode,
    0,
    1,
    0,
    0
  },
  {
    nonimmediate_operand,
    "",
    E_HImode,
    0,
    0,
    1,
    1
  },
  {
    general_operand,
    "",
    E_HImode,
    0,
    0,
    1,
    1
  },
  {
    0,
    "",
    E_VOIDmode,
    0,
    0,
    1,
    0
  },
  {
    0,
    "",
    E_VOIDmode,
    0,
    1,
    0,
    0
  },
  {
    nonimmediate_operand,
    "",
    E_PSImode,
    0,
    0,
    1,
    1
  },
  {
    general_operand,
    "",
    E_PSImode,
    0,
    0,
    1,
    1
  },
  {
    0,
    "",
    E_VOIDmode,
    0,
    0,
    1,
    0
  },
};


#if GCC_VERSION >= 2007
__extension__
#endif

const struct insn_data_d insn_data[] = 
{
  /* <internal>:0 */
  {
    "*placeholder_for_nothing",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    { 0 },
    &operand_data[0],
    0,
    0,
    0,
    0,
    0
  },
  /* ../../../gcc/gcc/config/msp430/msp430.md:86 */
  {
    "push",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "PUSH\t%0",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_push },
    &operand_data[1],
    1,
    1,
    0,
    1,
    1
  },
  /* ../../../gcc/gcc/config/msp430/msp430.md:93 */
  {
    "pusha",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "PUSHX.A\t%0",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_pusha },
    &operand_data[2],
    1,
    1,
    0,
    1,
    1
  },
  /* ../../../gcc/gcc/config/msp430/msp430.md:100 */
  {
    "pushm",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "PUSHM%b0\t%1, %0",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_pushm },
    &operand_data[3],
    2,
    2,
    0,
    1,
    1
  },
  /* ../../../gcc/gcc/config/msp430/msp430.md:107 */
  {
    "pop",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "POP\t%0",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_pop },
    &operand_data[5],
    1,
    1,
    0,
    1,
    1
  },
  /* ../../../gcc/gcc/config/msp430/msp430.md:114 */
  {
    "popa",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "POPX.A\t%0",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_popa },
    &operand_data[6],
    1,
    1,
    0,
    1,
    1
  },
  /* ../../../gcc/gcc/config/msp430/msp430.md:132 */
  {
    "popm",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "POPM%b0\t%2, r%J1",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_popm },
    &operand_data[7],
    3,
    3,
    0,
    1,
    1
  },
  /* ../../../gcc/gcc/config/msp430/msp430.md:156 */
  {
    "grow_and_swap",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .function = output_7 },
#else
    { 0, 0, output_7 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_grow_and_swap },
    &operand_data[0],
    0,
    0,
    0,
    0,
    3
  },
  /* ../../../gcc/gcc/config/msp430/msp430.md:166 */
  {
    "swap_and_shrink",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .function = output_8 },
#else
    { 0, 0, output_8 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_swap_and_shrink },
    &operand_data[0],
    0,
    0,
    0,
    0,
    3
  },
  /* ../../../gcc/gcc/config/msp430/msp430.md:176 */
  {
    "movqihi",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .multi = output_9 },
#else
    { 0, output_9, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_movqihi },
    &operand_data[10],
    2,
    2,
    0,
    2,
    2
  },
  /* ../../../gcc/gcc/config/msp430/msp430.md:185 */
  {
    "movqi_topbyte",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "PUSHM.A\t#1,%1 { POPM.W\t#1,%0 { POPM.W\t#1,%0",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_movqi_topbyte },
    &operand_data[12],
    2,
    2,
    0,
    1,
    1
  },
  /* ../../../gcc/gcc/config/msp430/msp430.md:192 */
  {
    "movqi",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .function = output_11 },
#else
    { 0, 0, output_11 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_movqi },
    &operand_data[14],
    2,
    2,
    0,
    2,
    3
  },
  /* ../../../gcc/gcc/config/msp430/msp430.md:203 */
  {
    "movhi",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .function = output_12 },
#else
    { 0, 0, output_12 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_movhi },
    &operand_data[16],
    2,
    2,
    0,
    3,
    3
  },
  /* ../../../gcc/gcc/config/msp430/msp430.md:222 */
  {
    "movsi_s",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_movsi_s },
    &operand_data[18],
    2,
    2,
    0,
    1,
    1
  },
  /* ../../../gcc/gcc/config/msp430/msp430.md:235 */
  {
    "movsi_x",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "#",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_movsi_x },
    &operand_data[20],
    2,
    2,
    0,
    1,
    1
  },
  /* ../../../gcc/gcc/config/msp430/msp430.md:249 */
  {
    "movpsi",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .multi = output_15 },
#else
    { 0, output_15, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_movpsi },
    &operand_data[22],
    2,
    2,
    0,
    5,
    2
  },
  /* ../../../gcc/gcc/config/msp430/msp430.md:267 */
  {
    "movsipsi2",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "PUSH.W\t%H1 { PUSH.W\t%L1 { POPM.A #1, %0 ; Move reg-pair %L1:%H1 into pointer %0",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_movsipsi2 },
    &operand_data[24],
    2,
    2,
    0,
    1,
    1
  },
  /* ../../../gcc/gcc/config/msp430/msp430.md:275 */
  {
    "*movpsihi2_lo",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "MOVA\t%1, %0",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { 0 },
    &operand_data[26],
    2,
    2,
    0,
    1,
    1
  },
  /* ../../../gcc/gcc/config/msp430/msp430.md:285 */
  {
    "addpsi3",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .multi = output_18 },
#else
    { 0, output_18, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_addpsi3 },
    &operand_data[28],
    3,
    3,
    0,
    2,
    2
  },
  /* ../../../gcc/gcc/config/msp430/msp430.md:295 */
  {
    "addqi3",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .function = output_19 },
#else
    { 0, 0, output_19 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_addqi3 },
    &operand_data[31],
    3,
    3,
    0,
    2,
    3
  },
  /* ../../../gcc/gcc/config/msp430/msp430.md:307 */
  {
    "addhi3",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .function = output_20 },
#else
    { 0, 0, output_20 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_addhi3 },
    &operand_data[34],
    3,
    3,
    0,
    2,
    3
  },
  /* ../../../gcc/gcc/config/msp430/msp430.md:323 */
  {
    "addsipsi3",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "ADD%X2.W\t%L2, %L0 { ADDC%X2.W\t%H2, %H0 { PUSH.W\t%H0 { PUSH.W\t%L0 { POPM.A\t#1, %0",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_addsipsi3 },
    &operand_data[37],
    3,
    3,
    0,
    1,
    1
  },
  /* ../../../gcc/gcc/config/msp430/msp430.md:331 */
  {
    "addsi3",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .function = output_22 },
#else
    { 0, 0, output_22 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_addsi3 },
    &operand_data[40],
    3,
    3,
    0,
    2,
    3
  },
  /* ../../../gcc/gcc/config/msp430/msp430.md:370 */
  {
    "addhi3_cy",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .function = output_23 },
#else
    { 0, 0, output_23 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_addhi3_cy },
    &operand_data[43],
    3,
    3,
    2,
    2,
    3
  },
  /* ../../../gcc/gcc/config/msp430/msp430.md:387 */
  {
    "addhi3_cy_i",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .multi = output_24 },
#else
    { 0, output_24, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_addhi3_cy_i },
    &operand_data[46],
    4,
    4,
    1,
    2,
    2
  },
  /* ../../../gcc/gcc/config/msp430/msp430.md:403 */
  {
    "addchi4_cy",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .function = output_25 },
#else
    { 0, 0, output_25 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_addchi4_cy },
    &operand_data[50],
    3,
    3,
    0,
    2,
    3
  },
  /* ../../../gcc/gcc/config/msp430/msp430.md:461 */
  {
    "subpsi3",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .multi = output_26 },
#else
    { 0, output_26, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_subpsi3 },
    &operand_data[53],
    3,
    3,
    0,
    4,
    2
  },
  /* ../../../gcc/gcc/config/msp430/msp430.md:474 */
  {
    "subqi3",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .function = output_27 },
#else
    { 0, 0, output_27 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_subqi3 },
    &operand_data[56],
    3,
    3,
    0,
    4,
    3
  },
  /* ../../../gcc/gcc/config/msp430/msp430.md:489 */
  {
    "subhi3",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .function = output_28 },
#else
    { 0, 0, output_28 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_subhi3 },
    &operand_data[59],
    3,
    3,
    0,
    4,
    3
  },
  /* ../../../gcc/gcc/config/msp430/msp430.md:503 */
  {
    "subsi3",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .function = output_29 },
#else
    { 0, 0, output_29 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_subsi3 },
    &operand_data[62],
    3,
    3,
    0,
    1,
    3
  },
  /* ../../../gcc/gcc/config/msp430/msp430.md:514 */
  {
    "*bicqi_cg",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .multi = output_30 },
#else
    { 0, output_30, 0 },
#endif
    { 0 },
    &operand_data[65],
    3,
    3,
    0,
    2,
    2
  },
  /* ../../../gcc/gcc/config/msp430/msp430.md:514 */
  {
    "*bichi_cg",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .multi = output_31 },
#else
    { 0, output_31, 0 },
#endif
    { 0 },
    &operand_data[68],
    3,
    3,
    0,
    2,
    2
  },
  /* ../../../gcc/gcc/config/msp430/msp430.md:514 */
  {
    "*bicpsi_cg",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .multi = output_32 },
#else
    { 0, output_32, 0 },
#endif
    { 0 },
    &operand_data[71],
    3,
    3,
    0,
    2,
    2
  },
  /* ../../../gcc/gcc/config/msp430/msp430.md:524 */
  {
    "bicqi3",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .function = output_33 },
#else
    { 0, 0, output_33 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_bicqi3 },
    &operand_data[74],
    3,
    3,
    0,
    2,
    3
  },
  /* ../../../gcc/gcc/config/msp430/msp430.md:524 */
  {
    "bichi3",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .function = output_34 },
#else
    { 0, 0, output_34 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_bichi3 },
    &operand_data[77],
    3,
    3,
    0,
    2,
    3
  },
  /* ../../../gcc/gcc/config/msp430/msp430.md:524 */
  {
    "bicpsi3",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .function = output_35 },
#else
    { 0, 0, output_35 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_bicpsi3 },
    &operand_data[80],
    3,
    3,
    0,
    2,
    3
  },
  /* ../../../gcc/gcc/config/msp430/msp430.md:536 */
  {
    "andqi3",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .function = output_36 },
#else
    { 0, 0, output_36 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_andqi3 },
    &operand_data[83],
    3,
    3,
    0,
    3,
    3
  },
  /* ../../../gcc/gcc/config/msp430/msp430.md:536 */
  {
    "andhi3",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .function = output_37 },
#else
    { 0, 0, output_37 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_andhi3 },
    &operand_data[86],
    3,
    3,
    0,
    3,
    3
  },
  /* ../../../gcc/gcc/config/msp430/msp430.md:536 */
  {
    "andpsi3",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .function = output_38 },
#else
    { 0, 0, output_38 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_andpsi3 },
    &operand_data[89],
    3,
    3,
    0,
    3,
    3
  },
  /* ../../../gcc/gcc/config/msp430/msp430.md:549 */
  {
    "iorqi3",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .function = output_39 },
#else
    { 0, 0, output_39 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_iorqi3 },
    &operand_data[31],
    3,
    3,
    0,
    2,
    3
  },
  /* ../../../gcc/gcc/config/msp430/msp430.md:549 */
  {
    "iorhi3",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .function = output_40 },
#else
    { 0, 0, output_40 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_iorhi3 },
    &operand_data[34],
    3,
    3,
    0,
    2,
    3
  },
  /* ../../../gcc/gcc/config/msp430/msp430.md:549 */
  {
    "iorpsi3",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .function = output_41 },
#else
    { 0, 0, output_41 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_iorpsi3 },
    &operand_data[92],
    3,
    3,
    0,
    2,
    3
  },
  /* ../../../gcc/gcc/config/msp430/msp430.md:561 */
  {
    "xorqi3",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .function = output_42 },
#else
    { 0, 0, output_42 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_xorqi3 },
    &operand_data[31],
    3,
    3,
    0,
    2,
    3
  },
  /* ../../../gcc/gcc/config/msp430/msp430.md:561 */
  {
    "xorhi3",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .function = output_43 },
#else
    { 0, 0, output_43 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_xorhi3 },
    &operand_data[34],
    3,
    3,
    0,
    2,
    3
  },
  /* ../../../gcc/gcc/config/msp430/msp430.md:561 */
  {
    "xorpsi3",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .function = output_44 },
#else
    { 0, 0, output_44 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_xorpsi3 },
    &operand_data[92],
    3,
    3,
    0,
    2,
    3
  },
  /* ../../../gcc/gcc/config/msp430/msp430.md:574 */
  {
    "one_cmplqi2",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .multi = output_45 },
#else
    { 0, output_45, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_one_cmplqi2 },
    &operand_data[95],
    2,
    2,
    0,
    2,
    2
  },
  /* ../../../gcc/gcc/config/msp430/msp430.md:574 */
  {
    "one_cmplhi2",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .multi = output_46 },
#else
    { 0, output_46, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_one_cmplhi2 },
    &operand_data[97],
    2,
    2,
    0,
    2,
    2
  },
  /* ../../../gcc/gcc/config/msp430/msp430.md:574 */
  {
    "one_cmplpsi2",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .multi = output_47 },
#else
    { 0, output_47, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_one_cmplpsi2 },
    &operand_data[99],
    2,
    2,
    0,
    2,
    2
  },
  /* ../../../gcc/gcc/config/msp430/msp430.md:583 */
  {
    "extendqihi2",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .multi = output_48 },
#else
    { 0, output_48, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_extendqihi2 },
    &operand_data[101],
    2,
    2,
    0,
    2,
    2
  },
  /* ../../../gcc/gcc/config/msp430/msp430.md:592 */
  {
    "zero_extendqihi2",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .multi = output_49 },
#else
    { 0, output_49, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_zero_extendqihi2 },
    &operand_data[103],
    2,
    2,
    0,
    4,
    2
  },
  /* ../../../gcc/gcc/config/msp430/msp430.md:614 */
  {
    "zero_extendhipsi2",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .multi = output_50 },
#else
    { 0, output_50, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_zero_extendhipsi2 },
    &operand_data[105],
    2,
    2,
    0,
    2,
    2
  },
  /* ../../../gcc/gcc/config/msp430/msp430.md:623 */
  {
    "truncpsihi2",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "MOVX\t%1, %0",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_truncpsihi2 },
    &operand_data[107],
    2,
    2,
    0,
    1,
    1
  },
  /* ../../../gcc/gcc/config/msp430/msp430.md:630 */
  {
    "extendhisi2",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .function = output_52 },
#else
    { 0, 0, output_52 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_extendhisi2 },
    &operand_data[109],
    2,
    2,
    0,
    1,
    3
  },
  /* ../../../gcc/gcc/config/msp430/msp430.md:637 */
  {
    "extendhipsi2",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "RLAM.A #4, %0 { RRAM.A #4, %0",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_extendhipsi2 },
    &operand_data[111],
    2,
    2,
    0,
    1,
    1
  },
  /* ../../../gcc/gcc/config/msp430/msp430.md:649 */
  {
    "zero_extendqisi2",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "MOV%X1.B\t%1,%L0 { CLR\t%H0",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_zero_extendqisi2 },
    &operand_data[113],
    2,
    2,
    0,
    1,
    1
  },
  /* ../../../gcc/gcc/config/msp430/msp430.md:656 */
  {
    "zero_extendhisi2",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .function = output_55 },
#else
    { 0, 0, output_55 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_zero_extendhisi2 },
    &operand_data[115],
    2,
    2,
    0,
    2,
    3
  },
  /* ../../../gcc/gcc/config/msp430/msp430.md:667 */
  {
    "zero_extendhisipsi2",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .multi = output_56 },
#else
    { 0, output_56, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_zero_extendhisipsi2 },
    &operand_data[117],
    2,
    2,
    0,
    2,
    2
  },
  /* ../../../gcc/gcc/config/msp430/msp430.md:676 */
  {
    "extend_and_shift1_hipsi2",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "RLAM.A #4, %0 { RRAM.A #3, %0",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_extend_and_shift1_hipsi2 },
    &operand_data[111],
    2,
    2,
    0,
    1,
    1
  },
  /* ../../../gcc/gcc/config/msp430/msp430.md:684 */
  {
    "extend_and_shift2_hipsi2",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "RLAM.A #4, %0 { RRAM.A #2, %0",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_extend_and_shift2_hipsi2 },
    &operand_data[111],
    2,
    2,
    0,
    1,
    1
  },
  /* ../../../gcc/gcc/config/msp430/msp430.md:710 */
  {
    "zero_extendpsisi2",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .function = output_59 },
#else
    { 0, 0, output_59 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_zero_extendpsisi2 },
    &operand_data[119],
    2,
    2,
    0,
    1,
    3
  },
  /* ../../../gcc/gcc/config/msp430/msp430.md:730 */
  {
    "extendpsisi2",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .function = output_60 },
#else
    { 0, 0, output_60 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_extendpsisi2 },
    &operand_data[121],
    2,
    2,
    0,
    1,
    3
  },
  /* ../../../gcc/gcc/config/msp430/msp430.md:749 */
  {
    "truncsipsi2",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "PUSH.W\t%H1 { PUSH.W\t%L1 { POPM.A\t#1, %L0",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_truncsipsi2 },
    &operand_data[24],
    2,
    2,
    0,
    1,
    1
  },
  /* ../../../gcc/gcc/config/msp430/msp430.md:811 */
  {
    "slli_1",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "RLA%X0.W\t%0",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_slli_1 },
    &operand_data[123],
    2,
    2,
    0,
    1,
    1
  },
  /* ../../../gcc/gcc/config/msp430/msp430.md:819 */
  {
    "430x_shift_left",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .function = output_63 },
#else
    { 0, 0, output_63 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_430x_shift_left },
    &operand_data[125],
    3,
    3,
    0,
    1,
    3
  },
  /* ../../../gcc/gcc/config/msp430/msp430.md:831 */
  {
    "slll_1",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "RLA%X0.W\t%L0 { RLC%X0.W\t%H0",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_slll_1 },
    &operand_data[128],
    2,
    2,
    0,
    1,
    1
  },
  /* ../../../gcc/gcc/config/msp430/msp430.md:839 */
  {
    "slll_2",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "RLA%X0.W\t%L0 { RLC%X0.W\t%H0 { RLA%X0.W\t%L0 { RLC%X0.W\t%H0",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_slll_2 },
    &operand_data[128],
    2,
    2,
    0,
    1,
    1
  },
  /* ../../../gcc/gcc/config/msp430/msp430.md:899 */
  {
    "srai_1",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "RRA%X0.W\t%0",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_srai_1 },
    &operand_data[130],
    2,
    2,
    0,
    1,
    1
  },
  /* ../../../gcc/gcc/config/msp430/msp430.md:907 */
  {
    "430x_arithmetic_shift_right",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .function = output_67 },
#else
    { 0, 0, output_67 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_430x_arithmetic_shift_right },
    &operand_data[125],
    3,
    3,
    0,
    1,
    3
  },
  /* ../../../gcc/gcc/config/msp430/msp430.md:919 */
  {
    "srap_1",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "RRAM.A #1,%0",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_srap_1 },
    &operand_data[132],
    2,
    2,
    0,
    1,
    1
  },
  /* ../../../gcc/gcc/config/msp430/msp430.md:927 */
  {
    "srap_2",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "RRAM.A #2,%0",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_srap_2 },
    &operand_data[132],
    2,
    2,
    0,
    1,
    1
  },
  /* ../../../gcc/gcc/config/msp430/msp430.md:935 */
  {
    "sral_1",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "RRA%X0.W\t%H0 { RRC%X0.W\t%L0",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_sral_1 },
    &operand_data[128],
    2,
    2,
    0,
    1,
    1
  },
  /* ../../../gcc/gcc/config/msp430/msp430.md:943 */
  {
    "sral_2",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "RRA%X0.W\t%H0 { RRC%X0.W\t%L0 { RRA%X0.W\t%H0 { RRC%X0.W\t%L0",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_sral_2 },
    &operand_data[128],
    2,
    2,
    0,
    1,
    1
  },
  /* ../../../gcc/gcc/config/msp430/msp430.md:1002 */
  {
    "srli_1",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "CLRC { RRC%X0.W\t%0",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_srli_1 },
    &operand_data[123],
    2,
    2,
    0,
    1,
    1
  },
  /* ../../../gcc/gcc/config/msp430/msp430.md:1010 */
  {
    "430x_logical_shift_right",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .function = output_73 },
#else
    { 0, 0, output_73 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_430x_logical_shift_right },
    &operand_data[125],
    3,
    3,
    0,
    1,
    3
  },
  /* ../../../gcc/gcc/config/msp430/msp430.md:1020 */
  {
    "srlp_1",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "RRUM.A #1,%0",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_srlp_1 },
    &operand_data[132],
    2,
    2,
    0,
    1,
    1
  },
  /* ../../../gcc/gcc/config/msp430/msp430.md:1028 */
  {
    "srll_1",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "CLRC { RRC%X0.W\t%H0 { RRC%X0.W\t%L0",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_srll_1 },
    &operand_data[128],
    2,
    2,
    0,
    1,
    1
  },
  /* ../../../gcc/gcc/config/msp430/msp430.md:1036 */
  {
    "srll_2x",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "RRUX.W\t%H0 { RRC.W\t%L0 { RRUX.W\t%H0 { RRC.W\t%L0",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_srll_2x },
    &operand_data[134],
    2,
    2,
    0,
    1,
    1
  },
  /* ../../../gcc/gcc/config/msp430/msp430.md:1083 */
  {
    "epilogue_helper",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "BR%Q0\t#__mspabi_func_epilog_%J0",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_epilogue_helper },
    &operand_data[8],
    1,
    1,
    0,
    1,
    1
  },
  /* ../../../gcc/gcc/config/msp430/msp430.md:1089 */
  {
    "prologue_start_marker",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "; start of prologue",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_prologue_start_marker },
    &operand_data[0],
    0,
    0,
    0,
    0,
    1
  },
  /* ../../../gcc/gcc/config/msp430/msp430.md:1095 */
  {
    "prologue_end_marker",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "; end of prologue",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_prologue_end_marker },
    &operand_data[0],
    0,
    0,
    0,
    0,
    1
  },
  /* ../../../gcc/gcc/config/msp430/msp430.md:1101 */
  {
    "epilogue_start_marker",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "; start of epilogue",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_epilogue_start_marker },
    &operand_data[0],
    0,
    0,
    0,
    0,
    1
  },
  /* ../../../gcc/gcc/config/msp430/msp430.md:1109 */
  {
    "msp430_refsym_need_exit",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    ".refsym\t__crt0_call_exit",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_msp430_refsym_need_exit },
    &operand_data[0],
    0,
    0,
    0,
    0,
    1
  },
  /* ../../../gcc/gcc/config/msp430/msp430.md:1125 */
  {
    "call_internal",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "CALL%Q0\t%0",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_call_internal },
    &operand_data[136],
    2,
    2,
    0,
    1,
    1
  },
  /* ../../../gcc/gcc/config/msp430/msp430.md:1140 */
  {
    "call_value_internal",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "CALL%Q0\t%1",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_call_value_internal },
    &operand_data[138],
    3,
    3,
    0,
    1,
    1
  },
  /* ../../../gcc/gcc/config/msp430/msp430.md:1148 */
  {
    "msp_return",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .function = output_84 },
#else
    { 0, 0, output_84 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_msp_return },
    &operand_data[0],
    0,
    0,
    0,
    0,
    3
  },
  /* ../../../gcc/gcc/config/msp430/msp430.md:1170 */
  {
    "msp430_eh_epilogue",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "#",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_msp430_eh_epilogue },
    &operand_data[0],
    0,
    0,
    0,
    0,
    1
  },
  /* ../../../gcc/gcc/config/msp430/msp430.md:1179 */
  {
    "jump",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "BR%Q0\t#%l0",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_jump },
    &operand_data[137],
    1,
    1,
    0,
    0,
    1
  },
  /* ../../../gcc/gcc/config/msp430/msp430.md:1188 */
  {
    "indirect_jump",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "BR%Q0\t%0",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_indirect_jump },
    &operand_data[141],
    1,
    1,
    0,
    1,
    1
  },
  /* ../../../gcc/gcc/config/msp430/msp430.md:1211 */
  {
    "cbranchpsi4_real",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .multi = output_88 },
#else
    { 0, output_88, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_cbranchpsi4_real },
    &operand_data[142],
    4,
    4,
    0,
    3,
    2
  },
  /* ../../../gcc/gcc/config/msp430/msp430.md:1227 */
  {
    "cbranchqi4_real",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .function = output_89 },
#else
    { 0, 0, output_89 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_cbranchqi4_real },
    &operand_data[146],
    4,
    4,
    0,
    2,
    3
  },
  /* ../../../gcc/gcc/config/msp430/msp430.md:1244 */
  {
    "cbranchhi4_real",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .function = output_90 },
#else
    { 0, 0, output_90 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_cbranchhi4_real },
    &operand_data[150],
    4,
    4,
    0,
    2,
    3
  },
  /* ../../../gcc/gcc/config/msp430/msp430.md:1286 */
  {
    "cbranchpsi4_reversed",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .multi = output_91 },
#else
    { 0, output_91, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_cbranchpsi4_reversed },
    &operand_data[154],
    4,
    4,
    0,
    3,
    2
  },
  /* ../../../gcc/gcc/config/msp430/msp430.md:1302 */
  {
    "cbranchqi4_reversed",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .function = output_92 },
#else
    { 0, 0, output_92 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_cbranchqi4_reversed },
    &operand_data[158],
    4,
    4,
    0,
    2,
    3
  },
  /* ../../../gcc/gcc/config/msp430/msp430.md:1319 */
  {
    "cbranchhi4_reversed",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .function = output_93 },
#else
    { 0, 0, output_93 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_cbranchhi4_reversed },
    &operand_data[162],
    4,
    4,
    0,
    2,
    3
  },
  /* ../../../gcc/gcc/config/msp430/msp430.md:1336 */
  {
    "*bitbranchqi4",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .function = output_94 },
#else
    { 0, 0, output_94 },
#endif
    { 0 },
    &operand_data[166],
    3,
    3,
    0,
    2,
    3
  },
  /* ../../../gcc/gcc/config/msp430/msp430.md:1336 */
  {
    "*bitbranchhi4",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .function = output_95 },
#else
    { 0, 0, output_95 },
#endif
    { 0 },
    &operand_data[169],
    3,
    3,
    0,
    2,
    3
  },
  /* ../../../gcc/gcc/config/msp430/msp430.md:1336 */
  {
    "*bitbranchpsi4",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .function = output_96 },
#else
    { 0, 0, output_96 },
#endif
    { 0 },
    &operand_data[172],
    3,
    3,
    0,
    2,
    3
  },
  /* ../../../gcc/gcc/config/msp430/msp430.md:1353 */
  {
    "*bitbranchqi4",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .function = output_97 },
#else
    { 0, 0, output_97 },
#endif
    { 0 },
    &operand_data[175],
    3,
    3,
    0,
    1,
    3
  },
  /* ../../../gcc/gcc/config/msp430/msp430.md:1353 */
  {
    "*bitbranchhi4",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .function = output_98 },
#else
    { 0, 0, output_98 },
#endif
    { 0 },
    &operand_data[178],
    3,
    3,
    0,
    1,
    3
  },
  /* ../../../gcc/gcc/config/msp430/msp430.md:1353 */
  {
    "*bitbranchpsi4",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .function = output_99 },
#else
    { 0, 0, output_99 },
#endif
    { 0 },
    &operand_data[181],
    3,
    3,
    0,
    1,
    3
  },
  /* ../../../gcc/gcc/config/msp430/msp430.md:1369 */
  {
    "*bitbranchqi4",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .function = output_100 },
#else
    { 0, 0, output_100 },
#endif
    { 0 },
    &operand_data[175],
    3,
    3,
    0,
    1,
    3
  },
  /* ../../../gcc/gcc/config/msp430/msp430.md:1369 */
  {
    "*bitbranchhi4",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .function = output_101 },
#else
    { 0, 0, output_101 },
#endif
    { 0 },
    &operand_data[178],
    3,
    3,
    0,
    1,
    3
  },
  /* ../../../gcc/gcc/config/msp430/msp430.md:1369 */
  {
    "*bitbranchpsi4",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .function = output_102 },
#else
    { 0, 0, output_102 },
#endif
    { 0 },
    &operand_data[181],
    3,
    3,
    0,
    1,
    3
  },
  /* ../../../gcc/gcc/config/msp430/msp430.md:1385 */
  {
    "*bitbranchqi4",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .function = output_103 },
#else
    { 0, 0, output_103 },
#endif
    { 0 },
    &operand_data[175],
    3,
    3,
    0,
    1,
    3
  },
  /* ../../../gcc/gcc/config/msp430/msp430.md:1385 */
  {
    "*bitbranchhi4",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .function = output_104 },
#else
    { 0, 0, output_104 },
#endif
    { 0 },
    &operand_data[178],
    3,
    3,
    0,
    1,
    3
  },
  /* ../../../gcc/gcc/config/msp430/msp430.md:1385 */
  {
    "*bitbranchpsi4",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .function = output_105 },
#else
    { 0, 0, output_105 },
#endif
    { 0 },
    &operand_data[181],
    3,
    3,
    0,
    1,
    3
  },
  /* ../../../gcc/gcc/config/msp430/msp430.md:1404 */
  {
    "*bitbranchqi4_z",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .multi = output_106 },
#else
    { 0, output_106, 0 },
#endif
    { 0 },
    &operand_data[184],
    3,
    3,
    0,
    2,
    2
  },
  /* ../../../gcc/gcc/config/msp430/msp430.md:1404 */
  {
    "*bitbranchhi4_z",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .multi = output_107 },
#else
    { 0, output_107, 0 },
#endif
    { 0 },
    &operand_data[187],
    3,
    3,
    0,
    2,
    2
  },
  /* ../../../gcc/gcc/config/msp430/msp430.md:1404 */
  {
    "*bitbranchpsi4_z",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .multi = output_108 },
#else
    { 0, output_108, 0 },
#endif
    { 0 },
    &operand_data[190],
    3,
    3,
    0,
    2,
    2
  },
  /* ../../../gcc/gcc/config/msp430/msp430.md:1420 */
  {
    "*bitbranchqi4_z",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "BIT%X0%b0\t%p1, %0 { JEQ\t%l2",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { 0 },
    &operand_data[193],
    3,
    3,
    0,
    1,
    1
  },
  /* ../../../gcc/gcc/config/msp430/msp430.md:1420 */
  {
    "*bitbranchhi4_z",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "BIT%X0%b0\t%p1, %0 { JEQ\t%l2",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { 0 },
    &operand_data[196],
    3,
    3,
    0,
    1,
    1
  },
  /* ../../../gcc/gcc/config/msp430/msp430.md:1420 */
  {
    "*bitbranchpsi4_z",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "BIT%X0%b0\t%p1, %0 { JEQ\t%l2",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { 0 },
    &operand_data[199],
    3,
    3,
    0,
    1,
    1
  },
  /* ../../../gcc/gcc/config/msp430/msp430.md:1434 */
  {
    "*bitbranchqi4_z",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "BIT%X0%b0\t%p1, %0 { JNE\t%l2",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { 0 },
    &operand_data[193],
    3,
    3,
    0,
    1,
    1
  },
  /* ../../../gcc/gcc/config/msp430/msp430.md:1434 */
  {
    "*bitbranchhi4_z",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "BIT%X0%b0\t%p1, %0 { JNE\t%l2",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { 0 },
    &operand_data[196],
    3,
    3,
    0,
    1,
    1
  },
  /* ../../../gcc/gcc/config/msp430/msp430.md:1434 */
  {
    "*bitbranchpsi4_z",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "BIT%X0%b0\t%p1, %0 { JNE\t%l2",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { 0 },
    &operand_data[199],
    3,
    3,
    0,
    1,
    1
  },
  /* ../../../gcc/gcc/config/msp430/msp430.md:1448 */
  {
    "*bitbranchqi4_z",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "BIT%X0%b0\t%p1, %0 { JEQ\t%l2",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { 0 },
    &operand_data[193],
    3,
    3,
    0,
    1,
    1
  },
  /* ../../../gcc/gcc/config/msp430/msp430.md:1448 */
  {
    "*bitbranchhi4_z",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "BIT%X0%b0\t%p1, %0 { JEQ\t%l2",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { 0 },
    &operand_data[196],
    3,
    3,
    0,
    1,
    1
  },
  /* ../../../gcc/gcc/config/msp430/msp430.md:1448 */
  {
    "*bitbranchpsi4_z",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "BIT%X0%b0\t%p1, %0 { JEQ\t%l2",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { 0 },
    &operand_data[199],
    3,
    3,
    0,
    1,
    1
  },
  /* ../../../gcc/gcc/config/msp430/msp430.md:1465 */
  {
    "nop",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "NOP",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_nop },
    &operand_data[0],
    0,
    0,
    0,
    0,
    1
  },
  /* ../../../gcc/gcc/config/msp430/msp430.md:1471 */
  {
    "disable_interrupts",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "DINT \n\t NOP",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_disable_interrupts },
    &operand_data[0],
    0,
    0,
    0,
    0,
    1
  },
  /* ../../../gcc/gcc/config/msp430/msp430.md:1477 */
  {
    "enable_interrupts",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "EINT",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_enable_interrupts },
    &operand_data[0],
    0,
    0,
    0,
    0,
    1
  },
  /* ../../../gcc/gcc/config/msp430/msp430.md:1483 */
  {
    "push_intr_state",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "PUSH\tSR",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_push_intr_state },
    &operand_data[0],
    0,
    0,
    0,
    0,
    1
  },
  /* ../../../gcc/gcc/config/msp430/msp430.md:1489 */
  {
    "pop_intr_state",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "POP\tSR",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_pop_intr_state },
    &operand_data[0],
    0,
    0,
    0,
    0,
    1
  },
  /* ../../../gcc/gcc/config/msp430/msp430.md:1497 */
  {
    "bic_SR",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "BIC.W\t%0, %O0(SP)",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_bic_SR },
    &operand_data[202],
    1,
    1,
    0,
    1,
    1
  },
  /* ../../../gcc/gcc/config/msp430/msp430.md:1505 */
  {
    "bis_SR",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "BIS.W\t%0, %O0(SP)",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_bis_SR },
    &operand_data[202],
    1,
    1,
    0,
    1,
    1
  },
  /* ../../../gcc/gcc/config/msp430/msp430.md:1514 */
  {
    "andneghi3",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .function = output_125 },
#else
    { 0, 0, output_125 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_andneghi3 },
    &operand_data[203],
    3,
    3,
    0,
    1,
    3
  },
  /* ../../../gcc/gcc/config/msp430/msp430.md:1527 */
  {
    "delay_cycles_start",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "; Begin %J0 cycle delay",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_delay_cycles_start },
    &operand_data[8],
    1,
    1,
    0,
    1,
    1
  },
  /* ../../../gcc/gcc/config/msp430/msp430.md:1534 */
  {
    "delay_cycles_end",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "; End %J0 cycle delay",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_delay_cycles_end },
    &operand_data[8],
    1,
    1,
    0,
    1,
    1
  },
  /* ../../../gcc/gcc/config/msp430/msp430.md:1541 */
  {
    "delay_cycles_32",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "PUSH	r13\n\
	PUSH	r14\n\
	MOV.W	%A0, r13\n\
	MOV.W	%B0, r14\n\
1:	SUB.W	#1, r13\n\
	SUBC.W	#0, r14\n\
	JNE	1b\n\
	TST.W	r13\n\
	JNE	1b\n\
	POP	r14\n\
	POP	r13",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_delay_cycles_32 },
    &operand_data[8],
    2,
    2,
    0,
    1,
    1
  },
  /* ../../../gcc/gcc/config/msp430/msp430.md:1559 */
  {
    "delay_cycles_32x",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "PUSHM.A	#2,r14\n\
	MOV.W	%A0, r13\n\
	MOV.W	%B0, r14\n\
1:	SUB.W	#1, r13\n\
	SUBC.W	#0, r14\n\
	JNE	1b\n\
	TST.W	r13\n\
	JNE	1b\n\
	POPM.A	#2,r14",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_delay_cycles_32x },
    &operand_data[8],
    2,
    2,
    0,
    1,
    1
  },
  /* ../../../gcc/gcc/config/msp430/msp430.md:1575 */
  {
    "delay_cycles_16",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "PUSH	r13\n\
	MOV.W	%0, r13\n\
1:	SUB.W	#1, r13\n\
	JNE	1b\n\
	POP	r13",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_delay_cycles_16 },
    &operand_data[8],
    2,
    2,
    0,
    1,
    1
  },
  /* ../../../gcc/gcc/config/msp430/msp430.md:1587 */
  {
    "delay_cycles_16x",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "PUSHM.A	#1,r13\n\
	MOV.W	%0, r13\n\
1:	SUB.W	#1, r13\n\
	JNE	1b\n\
	POPM.A	#1,r13",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_delay_cycles_16x },
    &operand_data[8],
    2,
    2,
    0,
    1,
    1
  },
  /* ../../../gcc/gcc/config/msp430/msp430.md:1599 */
  {
    "delay_cycles_2",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "JMP	.+2",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_delay_cycles_2 },
    &operand_data[0],
    0,
    0,
    0,
    0,
    1
  },
  /* ../../../gcc/gcc/config/msp430/msp430.md:1605 */
  {
    "delay_cycles_1",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "NOP",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_delay_cycles_1 },
    &operand_data[0],
    0,
    0,
    0,
    0,
    1
  },
  /* ../../../gcc/gcc/config/msp430/msp430.md:1611 */
  {
    "mulhisi3",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .function = output_134 },
#else
    { 0, 0, output_134 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_mulhisi3 },
    &operand_data[206],
    3,
    3,
    0,
    1,
    3
  },
  /* ../../../gcc/gcc/config/msp430/msp430.md:1624 */
  {
    "umulhisi3",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .function = output_135 },
#else
    { 0, 0, output_135 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_umulhisi3 },
    &operand_data[206],
    3,
    3,
    0,
    1,
    3
  },
  /* ../../../gcc/gcc/config/msp430/msp430.md:1637 */
  {
    "mulsidi3",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .function = output_136 },
#else
    { 0, 0, output_136 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_mulsidi3 },
    &operand_data[209],
    3,
    3,
    0,
    1,
    3
  },
  /* ../../../gcc/gcc/config/msp430/msp430.md:1650 */
  {
    "umulsidi3",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .function = output_137 },
#else
    { 0, 0, output_137 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_umulsidi3 },
    &operand_data[209],
    3,
    3,
    0,
    1,
    3
  },
  /* ../../../gcc/gcc/config/msp430/msp430.md:215 */
  {
    "movsi",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_movsi },
    &operand_data[212],
    2,
    2,
    0,
    0,
    0
  },
  /* ../../../gcc/gcc/config/msp430/msp430.md:784 */
  {
    "ashlhi3",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_ashlhi3 },
    &operand_data[214],
    3,
    3,
    0,
    0,
    0
  },
  /* ../../../gcc/gcc/config/msp430/msp430.md:847 */
  {
    "ashlsi3",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_ashlsi3 },
    &operand_data[217],
    3,
    3,
    0,
    0,
    0
  },
  /* ../../../gcc/gcc/config/msp430/msp430.md:858 */
  {
    "ashldi3",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_ashldi3 },
    &operand_data[220],
    3,
    3,
    0,
    0,
    0
  },
  /* ../../../gcc/gcc/config/msp430/msp430.md:875 */
  {
    "ashrhi3",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_ashrhi3 },
    &operand_data[214],
    3,
    3,
    0,
    0,
    0
  },
  /* ../../../gcc/gcc/config/msp430/msp430.md:951 */
  {
    "ashrsi3",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_ashrsi3 },
    &operand_data[217],
    3,
    3,
    0,
    0,
    0
  },
  /* ../../../gcc/gcc/config/msp430/msp430.md:962 */
  {
    "ashrdi3",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_ashrdi3 },
    &operand_data[220],
    3,
    3,
    0,
    0,
    0
  },
  /* ../../../gcc/gcc/config/msp430/msp430.md:978 */
  {
    "lshrhi3",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_lshrhi3 },
    &operand_data[214],
    3,
    3,
    0,
    0,
    0
  },
  /* ../../../gcc/gcc/config/msp430/msp430.md:1044 */
  {
    "lshrsi3",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_lshrsi3 },
    &operand_data[217],
    3,
    3,
    0,
    0,
    0
  },
  /* ../../../gcc/gcc/config/msp430/msp430.md:1055 */
  {
    "lshrdi3",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_lshrdi3 },
    &operand_data[220],
    3,
    3,
    0,
    0,
    0
  },
  /* ../../../gcc/gcc/config/msp430/msp430.md:1071 */
  {
    "prologue",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_prologue },
    &operand_data[0],
    0,
    0,
    0,
    0,
    0
  },
  /* ../../../gcc/gcc/config/msp430/msp430.md:1077 */
  {
    "epilogue",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_epilogue },
    &operand_data[0],
    0,
    0,
    0,
    0,
    0
  },
  /* ../../../gcc/gcc/config/msp430/msp430.md:1118 */
  {
    "call",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_call },
    &operand_data[223],
    2,
    2,
    0,
    0,
    0
  },
  /* ../../../gcc/gcc/config/msp430/msp430.md:1132 */
  {
    "call_value",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_call_value },
    &operand_data[225],
    3,
    3,
    0,
    0,
    0
  },
  /* ../../../gcc/gcc/config/msp430/msp430.md:1159 */
  {
    "eh_return",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_eh_return },
    &operand_data[228],
    1,
    1,
    0,
    0,
    0
  },
  /* ../../../gcc/gcc/config/msp430/msp430.md:1198 */
  {
    "cbranchqi4",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_cbranchqi4 },
    &operand_data[229],
    4,
    4,
    0,
    0,
    0
  },
  /* ../../../gcc/gcc/config/msp430/msp430.md:1198 */
  {
    "cbranchhi4",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_cbranchhi4 },
    &operand_data[233],
    4,
    4,
    0,
    0,
    0
  },
  /* ../../../gcc/gcc/config/msp430/msp430.md:1198 */
  {
    "cbranchpsi4",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_cbranchpsi4 },
    &operand_data[237],
    4,
    4,
    0,
    0,
    0
  },
};


const char *
get_insn_name (int code)
{
  if (code == NOOP_MOVE_INSN_CODE)
    return "NOOP_MOVE";
  else
    return insn_data[code].name;
}
